/* GestureTarget.c generated by valac 0.56.18, the Vala compiler
 * generated from GestureTarget.vala, do not modify */

/*
 * Copyright 2025 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <clutter/clutter.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_GESTURE_TARGET (gala_gesture_target_get_type ())
#define GALA_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTarget))
#define GALA_IS_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TARGET))
#define GALA_GESTURE_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTargetIface))

typedef struct _GalaGestureTarget GalaGestureTarget;
typedef struct _GalaGestureTargetIface GalaGestureTargetIface;
typedef enum  {
	GALA_GESTURE_TARGET_UPDATE_TYPE_START,
	GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE,
	GALA_GESTURE_TARGET_UPDATE_TYPE_COMMIT,
	GALA_GESTURE_TARGET_UPDATE_TYPE_END
} GalaGestureTargetUpdateType;

#define GALA_GESTURE_TARGET_TYPE_UPDATE_TYPE (gala_gesture_target_update_type_get_type ())

struct _GalaGestureTargetIface {
	GTypeInterface parent_iface;
	void (*propagate) (GalaGestureTarget* self, GalaGestureTargetUpdateType update_type, GalaGestureAction action, gdouble progress);
	ClutterActor* (*get_actor) (GalaGestureTarget* self);
};

VALA_EXTERN GType gala_gesture_target_update_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_gesture_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTarget, g_object_unref)
VALA_EXTERN void gala_gesture_target_propagate (GalaGestureTarget* self,
                                    GalaGestureTargetUpdateType update_type,
                                    GalaGestureAction action,
                                    gdouble progress);
static void gala_gesture_target_real_propagate (GalaGestureTarget* self,
                                         GalaGestureTargetUpdateType update_type,
                                         GalaGestureAction action,
                                         gdouble progress);
VALA_EXTERN ClutterActor* gala_gesture_target_get_actor (GalaGestureTarget* self);
static GType gala_gesture_target_get_type_once (void);

 G_GNUC_NO_INLINE static GType
gala_gesture_target_update_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_GESTURE_TARGET_UPDATE_TYPE_START, "GALA_GESTURE_TARGET_UPDATE_TYPE_START", "start"}, {GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE, "GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE", "update"}, {GALA_GESTURE_TARGET_UPDATE_TYPE_COMMIT, "GALA_GESTURE_TARGET_UPDATE_TYPE_COMMIT", "commit"}, {GALA_GESTURE_TARGET_UPDATE_TYPE_END, "GALA_GESTURE_TARGET_UPDATE_TYPE_END", "end"}, {0, NULL, NULL}};
	GType gala_gesture_target_update_type_type_id;
	gala_gesture_target_update_type_type_id = g_enum_register_static ("GalaGestureTargetUpdateType", values);
	return gala_gesture_target_update_type_type_id;
}

GType
gala_gesture_target_update_type_get_type (void)
{
	static gsize gala_gesture_target_update_type_type_id__once = 0;
	if (g_once_init_enter (&gala_gesture_target_update_type_type_id__once)) {
		GType gala_gesture_target_update_type_type_id;
		gala_gesture_target_update_type_type_id = gala_gesture_target_update_type_get_type_once ();
		g_once_init_leave (&gala_gesture_target_update_type_type_id__once, gala_gesture_target_update_type_type_id);
	}
	return gala_gesture_target_update_type_type_id__once;
}

static void
gala_gesture_target_real_propagate (GalaGestureTarget* self,
                                    GalaGestureTargetUpdateType update_type,
                                    GalaGestureAction action,
                                    gdouble progress)
{
}

void
gala_gesture_target_propagate (GalaGestureTarget* self,
                               GalaGestureTargetUpdateType update_type,
                               GalaGestureAction action,
                               gdouble progress)
{
	GalaGestureTargetIface* _iface_;
#line 22 "../src/Gestures/GestureTarget.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Gestures/GestureTarget.vala"
	_iface_ = GALA_GESTURE_TARGET_GET_INTERFACE (self);
#line 22 "../src/Gestures/GestureTarget.vala"
	if (_iface_->propagate) {
#line 22 "../src/Gestures/GestureTarget.vala"
		_iface_->propagate (self, update_type, action, progress);
#line 117 "GestureTarget.c"
	}
}

ClutterActor*
gala_gesture_target_get_actor (GalaGestureTarget* self)
{
	GalaGestureTargetIface* _iface_;
#line 20 "../src/Gestures/GestureTarget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/Gestures/GestureTarget.vala"
	_iface_ = GALA_GESTURE_TARGET_GET_INTERFACE (self);
#line 20 "../src/Gestures/GestureTarget.vala"
	if (_iface_->get_actor) {
#line 20 "../src/Gestures/GestureTarget.vala"
		return _iface_->get_actor (self);
#line 133 "GestureTarget.c"
	}
#line 20 "../src/Gestures/GestureTarget.vala"
	return NULL;
#line 137 "GestureTarget.c"
}

static void
gala_gesture_target_default_init (GalaGestureTargetIface * iface,
                                  gpointer iface_data)
{
	/**
	     * The actor manipulated by the gesture. The associated frame clock
	     * will be used for animation timelines.
	     */
#line 8 "../src/Gestures/GestureTarget.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("actor", "actor", "actor", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8 "../src/Gestures/GestureTarget.vala"
	iface->propagate = gala_gesture_target_real_propagate;
#line 152 "GestureTarget.c"
}

 G_GNUC_NO_INLINE static GType
gala_gesture_target_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaGestureTargetIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_gesture_target_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gala_gesture_target_type_id;
	gala_gesture_target_type_id = g_type_register_static (G_TYPE_INTERFACE, "GalaGestureTarget", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gala_gesture_target_type_id, G_TYPE_OBJECT);
	return gala_gesture_target_type_id;
}

GType
gala_gesture_target_get_type (void)
{
	static gsize gala_gesture_target_type_id__once = 0;
	if (g_once_init_enter (&gala_gesture_target_type_id__once)) {
		GType gala_gesture_target_type_id;
		gala_gesture_target_type_id = gala_gesture_target_get_type_once ();
		g_once_init_leave (&gala_gesture_target_type_id__once, gala_gesture_target_type_id);
	}
	return gala_gesture_target_type_id__once;
}

