/* RootTarget.c generated by valac 0.56.18, the Vala compiler
 * generated from RootTarget.vala, do not modify */

/*
 * Copyright 2025 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <clutter/clutter.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_ROOT_TARGET (gala_root_target_get_type ())
#define GALA_ROOT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ROOT_TARGET, GalaRootTarget))
#define GALA_IS_ROOT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ROOT_TARGET))
#define GALA_ROOT_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_ROOT_TARGET, GalaRootTargetIface))

typedef struct _GalaRootTarget GalaRootTarget;
typedef struct _GalaRootTargetIface GalaRootTargetIface;

#define GALA_TYPE_GESTURE_TARGET (gala_gesture_target_get_type ())
#define GALA_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTarget))
#define GALA_IS_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TARGET))
#define GALA_GESTURE_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTargetIface))

typedef struct _GalaGestureTarget GalaGestureTarget;
typedef struct _GalaGestureTargetIface GalaGestureTargetIface;
typedef enum  {
	GALA_GESTURE_TARGET_UPDATE_TYPE_START,
	GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE,
	GALA_GESTURE_TARGET_UPDATE_TYPE_COMMIT,
	GALA_GESTURE_TARGET_UPDATE_TYPE_END
} GalaGestureTargetUpdateType;

#define GALA_GESTURE_TARGET_TYPE_UPDATE_TYPE (gala_gesture_target_update_type_get_type ())

#define GALA_TYPE_GESTURE_CONTROLLER (gala_gesture_controller_get_type ())
#define GALA_GESTURE_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureController))
#define GALA_GESTURE_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureControllerClass))
#define GALA_IS_GESTURE_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_CONTROLLER))
#define GALA_IS_GESTURE_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_CONTROLLER))
#define GALA_GESTURE_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureControllerClass))

typedef struct _GalaGestureController GalaGestureController;
typedef struct _GalaGestureControllerClass GalaGestureControllerClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaGestureTargetIface {
	GTypeInterface parent_iface;
	void (*propagate) (GalaGestureTarget* self, GalaGestureTargetUpdateType update_type, GalaGestureAction action, gdouble progress);
	ClutterActor* (*get_actor) (GalaGestureTarget* self);
};

struct _GalaRootTargetIface {
	GTypeInterface parent_iface;
};

VALA_EXTERN GType gala_gesture_target_update_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_gesture_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTarget, g_object_unref)
VALA_EXTERN GType gala_root_target_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_gesture_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureController, g_object_unref)
VALA_EXTERN void gala_root_target_add_gesture_controller (GalaRootTarget* self,
                                              GalaGestureController* controller);
VALA_EXTERN GalaRootTarget* gala_gesture_controller_get_target (GalaGestureController* self);
VALA_EXTERN void gala_gesture_controller_attached (GalaGestureController* self,
                                       GalaRootTarget* target);
VALA_EXTERN void gala_gesture_controller_detached (GalaGestureController* self);
static void _gala_gesture_controller_detached_gweak_notify (gpointer self,
                                                     GObject* object);
static GType gala_root_target_get_type_once (void);

static void
_gala_gesture_controller_detached_gweak_notify (gpointer self,
                                                GObject* object)
{
#line 11 "../src/Gestures/RootTarget.vala"
	gala_gesture_controller_detached ((GalaGestureController*) self);
#line 107 "RootTarget.c"
}

void
gala_root_target_add_gesture_controller (GalaRootTarget* self,
                                         GalaGestureController* controller)
{
	GalaRootTarget* _tmp0_;
	GalaRootTarget* _tmp1_;
#line 9 "../src/Gestures/RootTarget.vala"
	g_return_if_fail (controller != NULL);
#line 9 "../src/Gestures/RootTarget.vala"
	_tmp0_ = gala_gesture_controller_get_target (controller);
#line 9 "../src/Gestures/RootTarget.vala"
	_tmp1_ = _tmp0_;
#line 9 "../src/Gestures/RootTarget.vala"
	_vala_return_if_fail (_tmp1_ == NULL, "controller.target == null");
#line 10 "../src/Gestures/RootTarget.vala"
	gala_gesture_controller_attached (controller, self);
#line 11 "../src/Gestures/RootTarget.vala"
	g_object_weak_ref ((GObject*) self, _gala_gesture_controller_detached_gweak_notify, controller);
#line 128 "RootTarget.c"
}

static void
gala_root_target_default_init (GalaRootTargetIface * iface,
                               gpointer iface_data)
{
}

 G_GNUC_NO_INLINE static GType
gala_root_target_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaRootTargetIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_root_target_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gala_root_target_type_id;
	gala_root_target_type_id = g_type_register_static (G_TYPE_INTERFACE, "GalaRootTarget", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gala_root_target_type_id, G_TYPE_OBJECT);
	g_type_interface_add_prerequisite (gala_root_target_type_id, GALA_TYPE_GESTURE_TARGET);
	return gala_root_target_type_id;
}

GType
gala_root_target_get_type (void)
{
	static gsize gala_root_target_type_id__once = 0;
	if (g_once_init_enter (&gala_root_target_type_id__once)) {
		GType gala_root_target_type_id;
		gala_root_target_type_id = gala_root_target_get_type_once ();
		g_once_init_leave (&gala_root_target_type_id__once, gala_root_target_type_id);
	}
	return gala_root_target_type_id__once;
}

