/* WindowOverview.c generated by valac 0.56.18, the Vala compiler
 * generated from WindowOverview.vala, do not modify */

/*
 * Copyright 2012 Tom Beckmann
 * Copyright 2012 Rico Tzschichholz
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <clutter/clutter.h>
#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/meta-workspace-manager.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include <meta/keybindings.h>
#include <mtk/mtk.h>
#include <meta/prefs.h>

#define GALA_WINDOW_OVERVIEW_BORDER 10
#define GALA_WINDOW_OVERVIEW_TOP_GAP 30
#define GALA_WINDOW_OVERVIEW_BOTTOM_GAP 100
#define GALA_MULTITASKING_VIEW_ANIMATION_DURATION 250
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_GESTURE_TARGET (gala_gesture_target_get_type ())
#define GALA_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTarget))
#define GALA_IS_GESTURE_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_TARGET))
#define GALA_GESTURE_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_GESTURE_TARGET, GalaGestureTargetIface))

typedef struct _GalaGestureTarget GalaGestureTarget;
typedef struct _GalaGestureTargetIface GalaGestureTargetIface;
typedef enum  {
	GALA_GESTURE_TARGET_UPDATE_TYPE_START,
	GALA_GESTURE_TARGET_UPDATE_TYPE_UPDATE,
	GALA_GESTURE_TARGET_UPDATE_TYPE_COMMIT,
	GALA_GESTURE_TARGET_UPDATE_TYPE_END
} GalaGestureTargetUpdateType;

#define GALA_GESTURE_TARGET_TYPE_UPDATE_TYPE (gala_gesture_target_update_type_get_type ())

#define GALA_TYPE_ACTOR_TARGET (gala_actor_target_get_type ())
#define GALA_ACTOR_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ACTOR_TARGET, GalaActorTarget))
#define GALA_ACTOR_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ACTOR_TARGET, GalaActorTargetClass))
#define GALA_IS_ACTOR_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ACTOR_TARGET))
#define GALA_IS_ACTOR_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ACTOR_TARGET))
#define GALA_ACTOR_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ACTOR_TARGET, GalaActorTargetClass))

typedef struct _GalaActorTarget GalaActorTarget;
typedef struct _GalaActorTargetClass GalaActorTargetClass;
typedef struct _GalaActorTargetPrivate GalaActorTargetPrivate;

#define GALA_TYPE_ROOT_TARGET (gala_root_target_get_type ())
#define GALA_ROOT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ROOT_TARGET, GalaRootTarget))
#define GALA_IS_ROOT_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ROOT_TARGET))
#define GALA_ROOT_TARGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_ROOT_TARGET, GalaRootTargetIface))

typedef struct _GalaRootTarget GalaRootTarget;
typedef struct _GalaRootTargetIface GalaRootTargetIface;

#define GALA_TYPE_WINDOW_OVERVIEW (gala_window_overview_get_type ())
#define GALA_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview))
#define GALA_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))
#define GALA_IS_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_IS_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_WINDOW_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))

typedef struct _GalaWindowOverview GalaWindowOverview;
typedef struct _GalaWindowOverviewClass GalaWindowOverviewClass;
typedef struct _GalaWindowOverviewPrivate GalaWindowOverviewPrivate;

#define GALA_TYPE_GESTURE_CONTROLLER (gala_gesture_controller_get_type ())
#define GALA_GESTURE_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureController))
#define GALA_GESTURE_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureControllerClass))
#define GALA_IS_GESTURE_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_GESTURE_CONTROLLER))
#define GALA_IS_GESTURE_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_GESTURE_CONTROLLER))
#define GALA_GESTURE_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_GESTURE_CONTROLLER, GalaGestureControllerClass))

typedef struct _GalaGestureController GalaGestureController;
typedef struct _GalaGestureControllerClass GalaGestureControllerClass;

#define GALA_TYPE_WINDOW_CLONE_CONTAINER (gala_window_clone_container_get_type ())
#define GALA_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer))
#define GALA_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))
#define GALA_IS_WINDOW_CLONE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_IS_WINDOW_CLONE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_CLONE_CONTAINER))
#define GALA_WINDOW_CLONE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainerClass))

typedef struct _GalaWindowCloneContainer GalaWindowCloneContainer;
typedef struct _GalaWindowCloneContainerClass GalaWindowCloneContainerClass;
enum  {
	GALA_WINDOW_OVERVIEW_0_PROPERTY,
	GALA_WINDOW_OVERVIEW_WM_PROPERTY,
	GALA_WINDOW_OVERVIEW_NUM_PROPERTIES
};
static GParamSpec* gala_window_overview_properties[GALA_WINDOW_OVERVIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block65Data Block65Data;

struct _GalaGestureTargetIface {
	GTypeInterface parent_iface;
	void (*propagate) (GalaGestureTarget* self, GalaGestureTargetUpdateType update_type, GalaGestureAction action, gdouble progress);
	ClutterActor* (*get_actor) (GalaGestureTarget* self);
};

struct _GalaActorTarget {
	ClutterActor parent_instance;
	GalaActorTargetPrivate * priv;
};

struct _GalaActorTargetClass {
	ClutterActorClass parent_class;
	void (*start_progress) (GalaActorTarget* self, GalaGestureAction action);
	void (*update_progress) (GalaActorTarget* self, GalaGestureAction action, gdouble progress);
	void (*commit_progress) (GalaActorTarget* self, GalaGestureAction action, gdouble to);
	void (*end_progress) (GalaActorTarget* self, GalaGestureAction action);
};

struct _GalaRootTargetIface {
	GTypeInterface parent_iface;
};

struct _GalaWindowOverview {
	GalaActorTarget parent_instance;
	GalaWindowOverviewPrivate * priv;
};

struct _GalaWindowOverviewClass {
	GalaActorTargetClass parent_class;
};

struct _GalaWindowOverviewPrivate {
	GalaWindowManager* _wm;
	GalaGestureController* gesture_controller;
	GalaModalProxy* modal_proxy;
	GList* workspaces;
	GalaWindowCloneContainer* window_clone_container;
};

struct _Block65Data {
	int _ref_count_;
	GalaWindowOverview* self;
	MetaWindow* window;
};

static gint GalaWindowOverview_private_offset;
static gpointer gala_window_overview_parent_class = NULL;
static GalaRootTargetIface * gala_window_overview_gala_root_target_parent_iface = NULL;
static GalaActivatableComponentIface * gala_window_overview_gala_activatable_component_parent_iface = NULL;

VALA_EXTERN GType gala_gesture_target_update_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_gesture_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureTarget, g_object_unref)
VALA_EXTERN GType gala_actor_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaActorTarget, g_object_unref)
VALA_EXTERN GType gala_root_target_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gala_window_overview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowOverview, g_object_unref)
VALA_EXTERN GType gala_gesture_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaGestureController, g_object_unref)
VALA_EXTERN GType gala_window_clone_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowCloneContainer, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GalaWindowOverview* gala_window_overview_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowOverview* gala_window_overview_construct (GType object_type,
                                                    GalaWindowManager* wm);
static gboolean gala_window_overview_real_key_press_event (ClutterActor* base,
                                                    ClutterEvent* event);
static gboolean gala_window_overview_real_button_release_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_window_overview_real_is_opened (GalaActivatableComponent* base);
static void gala_window_overview_real_open (GalaActivatableComponent* base,
                                     GHashTable* hints);
VALA_EXTERN GalaWindowManager* gala_window_overview_get_wm (GalaWindowOverview* self);
static guint64* _variant_get2 (GVariant* value,
                        gint* result_length1);
VALA_EXTERN gboolean gala_notification_stack_is_notification (MetaWindow* window);
static gboolean _vala_uint64_array_contains (guint64 * stack,
                                      gssize stack_length,
                                      const guint64 needle);
static void gala_window_overview_add_window (GalaWindowOverview* self,
                                      MetaWindow* window);
static void _gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self);
static void gala_window_overview_remove_window (GalaWindowOverview* self,
                                         MetaWindow* window);
static void _gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                        MetaWindow* object,
                                                                        gpointer self);
static void gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                               gint num,
                                               MetaWindow* window);
static void _gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                                 gint object,
                                                                                 MetaWindow* p0,
                                                                                 gpointer self);
static gboolean gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                                 MetaKeyBinding* binding);
static gboolean _gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                         gpointer self);
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_new (GalaWindowManager* wm,
                                                           gfloat monitor_scale,
                                                           gboolean overview_mode);
VALA_EXTERN GalaWindowCloneContainer* gala_window_clone_container_construct (GType object_type,
                                                                 GalaWindowManager* wm,
                                                                 gfloat monitor_scale,
                                                                 gboolean overview_mode);
VALA_EXTERN void gala_window_clone_container_set_padding_top (GalaWindowCloneContainer* self,
                                                  gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_left (GalaWindowCloneContainer* self,
                                                   gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_right (GalaWindowCloneContainer* self,
                                                    gint value);
VALA_EXTERN void gala_window_clone_container_set_padding_bottom (GalaWindowCloneContainer* self,
                                                     gint value);
static void gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                          MetaWindow* window);
static void _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                       MetaWindow* window,
                                                                                       gpointer self);
static void _____lambda146_ (GalaWindowOverview* self);
static void ______lambda146__gala_window_clone_container_requested_close (GalaWindowCloneContainer* _sender,
                                                                   gpointer self);
static void _____lambda147_ (GalaWindowOverview* self);
static void ______lambda147__gala_window_clone_container_last_window_closed (GalaWindowCloneContainer* _sender,
                                                                      gpointer self);
VALA_EXTERN void gala_window_clone_container_add_window (GalaWindowCloneContainer* self,
                                             MetaWindow* window);
VALA_EXTERN void gala_gesture_controller_goto (GalaGestureController* self,
                                   gdouble to);
VALA_EXTERN void gala_window_clone_container_remove_window (GalaWindowCloneContainer* self,
                                                MetaWindow* window);
static Block65Data* block65_data_ref (Block65Data* _data65_);
static void block65_data_unref (void * _userdata_);
static gboolean ___lambda145_ (Block65Data* _data65_);
static gboolean ____lambda145__gsource_func (gpointer self);
static void gala_window_overview_real_close (GalaActivatableComponent* base,
                                      GHashTable* hints);
static gboolean __lambda144_ (GalaWindowOverview* self);
static void gala_window_overview_cleanup (GalaWindowOverview* self);
static gboolean ___lambda144__gsource_func (gpointer self);
static void gala_window_overview_set_wm (GalaWindowOverview* self,
                                  GalaWindowManager* value);
static GObject * gala_window_overview_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
VALA_EXTERN GalaGestureController* gala_gesture_controller_new (GalaGestureAction action,
                                                    GalaWindowManager* wm);
VALA_EXTERN GalaGestureController* gala_gesture_controller_construct (GType object_type,
                                                          GalaGestureAction action,
                                                          GalaWindowManager* wm);
VALA_EXTERN void gala_gesture_controller_set_enabled (GalaGestureController* self,
                                          gboolean value);
VALA_EXTERN void gala_root_target_add_gesture_controller (GalaRootTarget* self,
                                              GalaGestureController* controller);
static void gala_window_overview_finalize (GObject * obj);
static GType gala_window_overview_get_type_once (void);
static void _vala_gala_window_overview_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gala_window_overview_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
gala_window_overview_get_instance_private (GalaWindowOverview* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowOverview_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 19 "../src/Widgets/WindowOverview.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 306 "WindowOverview.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 19 "../src/Widgets/WindowOverview.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 314 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_construct (GType object_type,
                                GalaWindowManager* wm)
{
	GalaWindowOverview * self = NULL;
#line 22 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 23 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) g_object_new (object_type, "wm", wm, NULL);
#line 22 "../src/Widgets/WindowOverview.vala"
	return self;
#line 328 "WindowOverview.c"
}

GalaWindowOverview*
gala_window_overview_new (GalaWindowManager* wm)
{
#line 22 "../src/Widgets/WindowOverview.vala"
	return gala_window_overview_construct (GALA_TYPE_WINDOW_OVERVIEW, wm);
#line 336 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_key_press_event (ClutterActor* base,
                                           ClutterEvent* event)
{
	GalaWindowOverview * self;
	GalaWindowCloneContainer* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 36 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 36 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 37 "../src/Widgets/WindowOverview.vala"
	if (!gala_activatable_component_is_opened ((GalaActivatableComponent*) self)) {
#line 38 "../src/Widgets/WindowOverview.vala"
		result = CLUTTER_EVENT_PROPAGATE;
#line 38 "../src/Widgets/WindowOverview.vala"
		return result;
#line 357 "WindowOverview.c"
	}
#line 41 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->window_clone_container;
#line 41 "../src/Widgets/WindowOverview.vala"
	g_signal_emit_by_name ((ClutterActor*) _tmp0_, "key-press-event", event, &_tmp1_);
#line 41 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 41 "../src/Widgets/WindowOverview.vala"
	return result;
#line 367 "WindowOverview.c"
}

static gboolean
gala_window_overview_real_button_release_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaWindowOverview * self;
	gboolean result;
#line 44 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 44 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 45 "../src/Widgets/WindowOverview.vala"
	if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 46 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 384 "WindowOverview.c"
	}
#line 49 "../src/Widgets/WindowOverview.vala"
	result = CLUTTER_EVENT_STOP;
#line 49 "../src/Widgets/WindowOverview.vala"
	return result;
#line 390 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
gala_window_overview_real_is_opened (GalaActivatableComponent* base)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 55 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 56 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 56 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/Widgets/WindowOverview.vala"
	result = _tmp1_;
#line 56 "../src/Widgets/WindowOverview.vala"
	return result;
#line 413 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 66 "../src/Widgets/WindowOverview.vala"
	return self ? g_object_ref (self) : NULL;
#line 424 "WindowOverview.c"
}

static guint64*
_variant_get2 (GVariant* value,
               gint* result_length1)
{
	guint64* _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_tmp0_ = g_new (guint64, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
#line 71 "../src/Widgets/WindowOverview.vala"
	g_variant_iter_init (&_tmp1_, value);
#line 71 "../src/Widgets/WindowOverview.vala"
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
#line 71 "../src/Widgets/WindowOverview.vala"
		if (_tmp0__size == _tmp0__length) {
#line 71 "../src/Widgets/WindowOverview.vala"
			_tmp0__size = 2 * _tmp0__size;
#line 71 "../src/Widgets/WindowOverview.vala"
			_tmp0_ = g_renew (guint64, _tmp0_, _tmp0__size + 1);
#line 451 "WindowOverview.c"
		}
#line 71 "../src/Widgets/WindowOverview.vala"
		_tmp0_[_tmp0__length++] = g_variant_get_uint64 (_tmp2_);
#line 71 "../src/Widgets/WindowOverview.vala"
		g_variant_unref (_tmp2_);
#line 457 "WindowOverview.c"
	}
#line 71 "../src/Widgets/WindowOverview.vala"
	*result_length1 = _tmp0__length1;
#line 71 "../src/Widgets/WindowOverview.vala"
	return _tmp0_;
#line 463 "WindowOverview.c"
}

static gboolean
_vala_uint64_array_contains (guint64 * stack,
                             gssize stack_length,
                             const guint64 needle)
{
	gssize i;
#line 84 "../src/Widgets/WindowOverview.vala"
	for (i = 0; i < stack_length; i++) {
#line 84 "../src/Widgets/WindowOverview.vala"
		if (needle == stack[i]) {
#line 84 "../src/Widgets/WindowOverview.vala"
			return TRUE;
#line 478 "WindowOverview.c"
		}
	}
#line 84 "../src/Widgets/WindowOverview.vala"
	return FALSE;
#line 483 "WindowOverview.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5301 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5301 "glib-2.0.vapi"
	return result;
#line 494 "WindowOverview.c"
}

static void
_gala_window_overview_add_window_meta_workspace_window_added (MetaWorkspace* _sender,
                                                              MetaWindow* object,
                                                              gpointer self)
{
#line 107 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_add_window ((GalaWindowOverview*) self, object);
#line 504 "WindowOverview.c"
}

static void
_gala_window_overview_remove_window_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                   MetaWindow* object,
                                                                   gpointer self)
{
#line 108 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_remove_window ((GalaWindowOverview*) self, object);
#line 514 "WindowOverview.c"
}

static void
_gala_window_overview_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                            gint object,
                                                                            MetaWindow* p0,
                                                                            gpointer self)
{
#line 111 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_window_left_monitor ((GalaWindowOverview*) self, object, p0);
#line 525 "WindowOverview.c"
}

static gboolean
_gala_window_overview_keybinding_filter_gala_keybinding_filter (MetaKeyBinding* binding,
                                                                gpointer self)
{
	gboolean result;
	result = gala_window_overview_keybinding_filter ((GalaWindowOverview*) self, binding);
#line 116 "../src/Widgets/WindowOverview.vala"
	return result;
#line 536 "WindowOverview.c"
}

static void
_gala_window_overview_thumb_selected_gala_window_clone_container_window_selected (GalaWindowCloneContainer* _sender,
                                                                                  MetaWindow* window,
                                                                                  gpointer self)
{
#line 135 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_thumb_selected ((GalaWindowOverview*) self, window);
#line 546 "WindowOverview.c"
}

static void
_____lambda146_ (GalaWindowOverview* self)
{
#line 136 "../src/Widgets/WindowOverview.vala"
	gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 554 "WindowOverview.c"
}

static void
______lambda146__gala_window_clone_container_requested_close (GalaWindowCloneContainer* _sender,
                                                              gpointer self)
{
#line 136 "../src/Widgets/WindowOverview.vala"
	_____lambda146_ ((GalaWindowOverview*) self);
#line 563 "WindowOverview.c"
}

static void
_____lambda147_ (GalaWindowOverview* self)
{
#line 137 "../src/Widgets/WindowOverview.vala"
	gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 571 "WindowOverview.c"
}

static void
______lambda147__gala_window_clone_container_last_window_closed (GalaWindowCloneContainer* _sender,
                                                                 gpointer self)
{
#line 137 "../src/Widgets/WindowOverview.vala"
	_____lambda147_ ((GalaWindowOverview*) self);
#line 580 "WindowOverview.c"
}

static void
gala_window_overview_real_open (GalaActivatableComponent* base,
                                GHashTable* hints)
{
	GalaWindowOverview * self;
	MetaWorkspaceManager* manager = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	GList* _tmp4_;
	guint64* window_ids = NULL;
	gint window_ids_length1;
	gint _window_ids_size_;
	gboolean _tmp7_ = FALSE;
	GList* windows = NULL;
	GList* _tmp10_;
	GList* _tmp45_;
	GList* _tmp46_;
	GalaWindowManager* _tmp50_;
	MetaDisplay* _tmp51_;
	GalaWindowManager* _tmp52_;
	GalaModalProxy* _tmp53_;
	GalaModalProxy* _tmp54_;
	GalaModalProxy* _tmp55_;
	GalaGestureAction* _tmp56_;
	GalaGestureAction* _tmp57_;
	gint _tmp57__length1;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp58_;
	MetaDisplay* _tmp59_;
	GList* _tmp76_;
	GalaGestureController* _tmp85_;
#line 62 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 63 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 63 "../src/Widgets/WindowOverview.vala"
	self->priv->workspaces = NULL;
#line 64 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 64 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 64 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 64 "../src/Widgets/WindowOverview.vala"
	manager = _tmp2_;
#line 65 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = manager;
#line 65 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_workspace_manager_get_workspaces (_tmp3_);
#line 634 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 65 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp4_;
#line 65 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 642 "WindowOverview.c"
			MetaWorkspace* workspace = NULL;
#line 65 "../src/Widgets/WindowOverview.vala"
			workspace = (MetaWorkspace*) workspace_it->data;
#line 646 "WindowOverview.c"
			{
				MetaWorkspace* _tmp5_;
				MetaWorkspace* _tmp6_;
#line 66 "../src/Widgets/WindowOverview.vala"
				_tmp5_ = workspace;
#line 66 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = _g_object_ref0 (_tmp5_);
#line 66 "../src/Widgets/WindowOverview.vala"
				self->priv->workspaces = g_list_append (self->priv->workspaces, _tmp6_);
#line 656 "WindowOverview.c"
			}
		}
	}
#line 69 "../src/Widgets/WindowOverview.vala"
	window_ids = NULL;
#line 69 "../src/Widgets/WindowOverview.vala"
	window_ids_length1 = 0;
#line 69 "../src/Widgets/WindowOverview.vala"
	_window_ids_size_ = window_ids_length1;
#line 70 "../src/Widgets/WindowOverview.vala"
	if (hints != NULL) {
#line 70 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = g_hash_table_contains (hints, "windows");
#line 670 "WindowOverview.c"
	} else {
#line 70 "../src/Widgets/WindowOverview.vala"
		_tmp7_ = FALSE;
#line 674 "WindowOverview.c"
	}
#line 70 "../src/Widgets/WindowOverview.vala"
	if (_tmp7_) {
#line 678 "WindowOverview.c"
		gconstpointer _tmp8_;
		guint64* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
#line 71 "../src/Widgets/WindowOverview.vala"
		_tmp8_ = g_hash_table_lookup (hints, "windows");
#line 71 "../src/Widgets/WindowOverview.vala"
		_tmp9_ = _variant_get2 ((GVariant*) _tmp8_, &_tmp9__length1);
#line 71 "../src/Widgets/WindowOverview.vala"
		window_ids = (g_free (window_ids), NULL);
#line 71 "../src/Widgets/WindowOverview.vala"
		window_ids = _tmp9_;
#line 71 "../src/Widgets/WindowOverview.vala"
		window_ids_length1 = _tmp9__length1;
#line 71 "../src/Widgets/WindowOverview.vala"
		_window_ids_size_ = window_ids_length1;
#line 694 "WindowOverview.c"
	}
#line 74 "../src/Widgets/WindowOverview.vala"
	windows = NULL;
#line 75 "../src/Widgets/WindowOverview.vala"
	_tmp10_ = self->priv->workspaces;
#line 700 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 75 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp10_;
#line 75 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 708 "WindowOverview.c"
			MetaWorkspace* _tmp11_;
			MetaWorkspace* workspace = NULL;
#line 75 "../src/Widgets/WindowOverview.vala"
			_tmp11_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 75 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp11_;
#line 715 "WindowOverview.c"
			{
				MetaWorkspace* _tmp12_;
				GList* _tmp13_;
#line 76 "../src/Widgets/WindowOverview.vala"
				_tmp12_ = workspace;
#line 76 "../src/Widgets/WindowOverview.vala"
				_tmp13_ = meta_workspace_list_windows (_tmp12_);
#line 723 "WindowOverview.c"
				{
					GList* window_collection = NULL;
					GList* window_it = NULL;
#line 76 "../src/Widgets/WindowOverview.vala"
					window_collection = _tmp13_;
#line 76 "../src/Widgets/WindowOverview.vala"
					for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 731 "WindowOverview.c"
						MetaWindow* window = NULL;
#line 76 "../src/Widgets/WindowOverview.vala"
						window = (MetaWindow*) window_it->data;
#line 735 "WindowOverview.c"
						{
							gboolean _tmp14_ = FALSE;
							MetaWindow* _tmp15_;
							MetaWindowType _tmp16_;
							MetaWindowType _tmp17_;
							gboolean _tmp19_ = FALSE;
							gboolean _tmp20_ = FALSE;
							gboolean _tmp21_ = FALSE;
							MetaWindow* _tmp22_;
							MetaWindowType _tmp23_;
							MetaWindowType _tmp24_;
							gboolean _tmp36_ = FALSE;
							MetaWindow* _tmp37_;
							gboolean _tmp38_;
							gboolean _tmp39_;
							MetaWindow* _tmp43_;
							MetaWindow* _tmp44_;
#line 77 "../src/Widgets/WindowOverview.vala"
							_tmp15_ = window;
#line 77 "../src/Widgets/WindowOverview.vala"
							_tmp16_ = meta_window_get_window_type (_tmp15_);
#line 77 "../src/Widgets/WindowOverview.vala"
							_tmp17_ = _tmp16_;
#line 77 "../src/Widgets/WindowOverview.vala"
							if (_tmp17_ == META_WINDOW_DOCK) {
#line 77 "../src/Widgets/WindowOverview.vala"
								_tmp14_ = TRUE;
#line 763 "WindowOverview.c"
							} else {
								MetaWindow* _tmp18_;
#line 77 "../src/Widgets/WindowOverview.vala"
								_tmp18_ = window;
#line 77 "../src/Widgets/WindowOverview.vala"
								_tmp14_ = gala_notification_stack_is_notification (_tmp18_);
#line 770 "WindowOverview.c"
							}
#line 77 "../src/Widgets/WindowOverview.vala"
							if (_tmp14_) {
#line 78 "../src/Widgets/WindowOverview.vala"
								continue;
#line 776 "WindowOverview.c"
							}
#line 81 "../src/Widgets/WindowOverview.vala"
							_tmp22_ = window;
#line 81 "../src/Widgets/WindowOverview.vala"
							_tmp23_ = meta_window_get_window_type (_tmp22_);
#line 81 "../src/Widgets/WindowOverview.vala"
							_tmp24_ = _tmp23_;
#line 81 "../src/Widgets/WindowOverview.vala"
							if (_tmp24_ != META_WINDOW_NORMAL) {
#line 786 "WindowOverview.c"
								MetaWindow* _tmp25_;
								MetaWindowType _tmp26_;
								MetaWindowType _tmp27_;
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp25_ = window;
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp26_ = meta_window_get_window_type (_tmp25_);
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp27_ = _tmp26_;
#line 82 "../src/Widgets/WindowOverview.vala"
								_tmp21_ = _tmp27_ != META_WINDOW_DIALOG;
#line 798 "WindowOverview.c"
							} else {
#line 81 "../src/Widgets/WindowOverview.vala"
								_tmp21_ = FALSE;
#line 802 "WindowOverview.c"
							}
#line 81 "../src/Widgets/WindowOverview.vala"
							if (_tmp21_) {
#line 81 "../src/Widgets/WindowOverview.vala"
								_tmp20_ = TRUE;
#line 808 "WindowOverview.c"
							} else {
								MetaWindow* _tmp28_;
#line 83 "../src/Widgets/WindowOverview.vala"
								_tmp28_ = window;
#line 83 "../src/Widgets/WindowOverview.vala"
								_tmp20_ = meta_window_is_attached_dialog (_tmp28_);
#line 815 "WindowOverview.c"
							}
#line 81 "../src/Widgets/WindowOverview.vala"
							if (_tmp20_) {
#line 81 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = TRUE;
#line 821 "WindowOverview.c"
							} else {
								gboolean _tmp29_ = FALSE;
								guint64* _tmp30_;
								gint _tmp30__length1;
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp30_ = window_ids;
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp30__length1 = window_ids_length1;
#line 84 "../src/Widgets/WindowOverview.vala"
								if (_tmp30_ != NULL) {
#line 832 "WindowOverview.c"
									MetaWindow* _tmp31_;
									guint64* _tmp32_;
									gint _tmp32__length1;
#line 84 "../src/Widgets/WindowOverview.vala"
									_tmp31_ = window;
#line 84 "../src/Widgets/WindowOverview.vala"
									_tmp32_ = window_ids;
#line 84 "../src/Widgets/WindowOverview.vala"
									_tmp32__length1 = window_ids_length1;
#line 84 "../src/Widgets/WindowOverview.vala"
									_tmp29_ = !_vala_uint64_array_contains (_tmp32_, _tmp32__length1, meta_window_get_id (_tmp31_));
#line 844 "WindowOverview.c"
								} else {
#line 84 "../src/Widgets/WindowOverview.vala"
									_tmp29_ = FALSE;
#line 848 "WindowOverview.c"
								}
#line 84 "../src/Widgets/WindowOverview.vala"
								_tmp19_ = _tmp29_;
#line 852 "WindowOverview.c"
							}
#line 81 "../src/Widgets/WindowOverview.vala"
							if (_tmp19_) {
#line 856 "WindowOverview.c"
								MetaWindowActor* actor = NULL;
								MetaWindow* _tmp33_;
								GObject* _tmp34_;
								MetaWindowActor* _tmp35_;
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp33_ = window;
#line 86 "../src/Widgets/WindowOverview.vala"
								_tmp34_ = meta_window_get_compositor_private (_tmp33_);
#line 86 "../src/Widgets/WindowOverview.vala"
								actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, meta_window_actor_get_type (), MetaWindowActor);
#line 87 "../src/Widgets/WindowOverview.vala"
								_tmp35_ = actor;
#line 87 "../src/Widgets/WindowOverview.vala"
								clutter_actor_hide ((ClutterActor*) _tmp35_);
#line 89 "../src/Widgets/WindowOverview.vala"
								continue;
#line 873 "WindowOverview.c"
							}
#line 94 "../src/Widgets/WindowOverview.vala"
							_tmp37_ = window;
#line 94 "../src/Widgets/WindowOverview.vala"
							g_object_get (_tmp37_, "on-all-workspaces", &_tmp38_, NULL);
#line 94 "../src/Widgets/WindowOverview.vala"
							_tmp39_ = _tmp38_;
#line 94 "../src/Widgets/WindowOverview.vala"
							if (_tmp39_) {
#line 883 "WindowOverview.c"
								MetaWindow* _tmp40_;
								MetaWorkspace* _tmp41_;
								MetaWorkspace* _tmp42_;
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp40_ = window;
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp41_ = meta_window_get_workspace (_tmp40_);
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp42_ = workspace;
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp36_ = _tmp41_ != _tmp42_;
#line 895 "WindowOverview.c"
							} else {
#line 94 "../src/Widgets/WindowOverview.vala"
								_tmp36_ = FALSE;
#line 899 "WindowOverview.c"
							}
#line 94 "../src/Widgets/WindowOverview.vala"
							if (_tmp36_) {
#line 95 "../src/Widgets/WindowOverview.vala"
								continue;
#line 905 "WindowOverview.c"
							}
#line 98 "../src/Widgets/WindowOverview.vala"
							_tmp43_ = window;
#line 98 "../src/Widgets/WindowOverview.vala"
							_tmp44_ = _g_object_ref0 (_tmp43_);
#line 98 "../src/Widgets/WindowOverview.vala"
							windows = g_list_append (windows, _tmp44_);
#line 913 "WindowOverview.c"
						}
					}
#line 76 "../src/Widgets/WindowOverview.vala"
					(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 918 "WindowOverview.c"
				}
#line 75 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 922 "WindowOverview.c"
			}
		}
	}
#line 102 "../src/Widgets/WindowOverview.vala"
	_tmp45_ = windows;
#line 102 "../src/Widgets/WindowOverview.vala"
	if (vala_g_list_is_empty (_tmp45_)) {
#line 103 "../src/Widgets/WindowOverview.vala"
		(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 103 "../src/Widgets/WindowOverview.vala"
		window_ids = (g_free (window_ids), NULL);
#line 103 "../src/Widgets/WindowOverview.vala"
		return;
#line 936 "WindowOverview.c"
	}
#line 106 "../src/Widgets/WindowOverview.vala"
	_tmp46_ = self->priv->workspaces;
#line 940 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 106 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp46_;
#line 106 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 948 "WindowOverview.c"
			MetaWorkspace* _tmp47_;
			MetaWorkspace* workspace = NULL;
#line 106 "../src/Widgets/WindowOverview.vala"
			_tmp47_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 106 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp47_;
#line 955 "WindowOverview.c"
			{
				MetaWorkspace* _tmp48_;
				MetaWorkspace* _tmp49_;
#line 107 "../src/Widgets/WindowOverview.vala"
				_tmp48_ = workspace;
#line 107 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp48_, "window-added", (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self, 0);
#line 108 "../src/Widgets/WindowOverview.vala"
				_tmp49_ = workspace;
#line 108 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp49_, "window-removed", (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self, 0);
#line 106 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 969 "WindowOverview.c"
			}
		}
	}
#line 111 "../src/Widgets/WindowOverview.vala"
	_tmp50_ = self->priv->_wm;
#line 111 "../src/Widgets/WindowOverview.vala"
	_tmp51_ = meta_plugin_get_display ((MetaPlugin*) _tmp50_);
#line 111 "../src/Widgets/WindowOverview.vala"
	g_signal_connect_object (_tmp51_, "window-left-monitor", (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self, 0);
#line 113 "../src/Widgets/WindowOverview.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 115 "../src/Widgets/WindowOverview.vala"
	_tmp52_ = self->priv->_wm;
#line 115 "../src/Widgets/WindowOverview.vala"
	_tmp53_ = gala_window_manager_push_modal (_tmp52_, (ClutterActor*) self);
#line 115 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 115 "../src/Widgets/WindowOverview.vala"
	self->priv->modal_proxy = _tmp53_;
#line 116 "../src/Widgets/WindowOverview.vala"
	_tmp54_ = self->priv->modal_proxy;
#line 116 "../src/Widgets/WindowOverview.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp54_, _gala_window_overview_keybinding_filter_gala_keybinding_filter, self);
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp55_ = self->priv->modal_proxy;
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp56_ = g_new0 (GalaGestureAction, 1);
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp56_[0] = GALA_GESTURE_ACTION_ZOOM;
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp57_ = _tmp56_;
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp57__length1 = 1;
#line 117 "../src/Widgets/WindowOverview.vala"
	gala_modal_proxy_allow_actions (_tmp55_, _tmp57_, (gint) 1);
#line 117 "../src/Widgets/WindowOverview.vala"
	_tmp57_ = (g_free (_tmp57_), NULL);
#line 119 "../src/Widgets/WindowOverview.vala"
	_tmp58_ = self->priv->_wm;
#line 119 "../src/Widgets/WindowOverview.vala"
	_tmp59_ = meta_plugin_get_display ((MetaPlugin*) _tmp58_);
#line 119 "../src/Widgets/WindowOverview.vala"
	display = _tmp59_;
#line 1013 "WindowOverview.c"
	{
		gint i = 0;
#line 121 "../src/Widgets/WindowOverview.vala"
		i = 0;
#line 1018 "WindowOverview.c"
		{
			gboolean _tmp60_ = FALSE;
#line 121 "../src/Widgets/WindowOverview.vala"
			_tmp60_ = TRUE;
#line 121 "../src/Widgets/WindowOverview.vala"
			while (TRUE) {
#line 1025 "WindowOverview.c"
				MetaDisplay* _tmp62_;
				MtkRectangle geometry = {0};
				MetaDisplay* _tmp63_;
				MtkRectangle _tmp64_ = {0};
				gfloat scale = 0.0F;
				MetaDisplay* _tmp65_;
				GalaWindowManager* _tmp66_;
				MtkRectangle _tmp67_;
				MtkRectangle _tmp68_;
				MtkRectangle _tmp69_;
				MtkRectangle _tmp70_;
				GalaWindowCloneContainer* _tmp71_ = NULL;
				GalaWindowCloneContainer* _tmp72_;
				GalaWindowCloneContainer* _tmp73_;
				GalaWindowCloneContainer* _tmp74_;
				GalaWindowCloneContainer* _tmp75_;
#line 121 "../src/Widgets/WindowOverview.vala"
				if (!_tmp60_) {
#line 1044 "WindowOverview.c"
					gint _tmp61_;
#line 121 "../src/Widgets/WindowOverview.vala"
					_tmp61_ = i;
#line 121 "../src/Widgets/WindowOverview.vala"
					i = _tmp61_ + 1;
#line 1050 "WindowOverview.c"
				}
#line 121 "../src/Widgets/WindowOverview.vala"
				_tmp60_ = FALSE;
#line 121 "../src/Widgets/WindowOverview.vala"
				_tmp62_ = display;
#line 121 "../src/Widgets/WindowOverview.vala"
				if (!(i < meta_display_get_n_monitors (_tmp62_))) {
#line 121 "../src/Widgets/WindowOverview.vala"
					break;
#line 1060 "WindowOverview.c"
				}
#line 122 "../src/Widgets/WindowOverview.vala"
				_tmp63_ = display;
#line 122 "../src/Widgets/WindowOverview.vala"
				meta_display_get_monitor_geometry (_tmp63_, i, &_tmp64_);
#line 122 "../src/Widgets/WindowOverview.vala"
				geometry = _tmp64_;
#line 123 "../src/Widgets/WindowOverview.vala"
				_tmp65_ = display;
#line 123 "../src/Widgets/WindowOverview.vala"
				scale = meta_display_get_monitor_scale (_tmp65_, i);
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp66_ = self->priv->_wm;
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp67_ = geometry;
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp68_ = geometry;
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp69_ = geometry;
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp70_ = geometry;
#line 125 "../src/Widgets/WindowOverview.vala"
				_tmp71_ = gala_window_clone_container_new (_tmp66_, scale, TRUE);
#line 125 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_top (_tmp71_, GALA_WINDOW_OVERVIEW_TOP_GAP);
#line 125 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_left (_tmp71_, GALA_WINDOW_OVERVIEW_BORDER);
#line 125 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_right (_tmp71_, GALA_WINDOW_OVERVIEW_BORDER);
#line 125 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_set_padding_bottom (_tmp71_, GALA_WINDOW_OVERVIEW_BOTTOM_GAP);
#line 125 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_width ((ClutterActor*) _tmp71_, (gfloat) _tmp67_.width);
#line 125 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_height ((ClutterActor*) _tmp71_, (gfloat) _tmp68_.height);
#line 125 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_x ((ClutterActor*) _tmp71_, (gfloat) _tmp69_.x);
#line 125 "../src/Widgets/WindowOverview.vala"
				clutter_actor_set_y ((ClutterActor*) _tmp71_, (gfloat) _tmp70_.y);
#line 125 "../src/Widgets/WindowOverview.vala"
				g_object_ref_sink (_tmp71_);
#line 125 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (self->priv->window_clone_container);
#line 125 "../src/Widgets/WindowOverview.vala"
				self->priv->window_clone_container = _tmp71_;
#line 135 "../src/Widgets/WindowOverview.vala"
				_tmp72_ = self->priv->window_clone_container;
#line 135 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp72_, "window-selected", (GCallback) _gala_window_overview_thumb_selected_gala_window_clone_container_window_selected, self, 0);
#line 136 "../src/Widgets/WindowOverview.vala"
				_tmp73_ = self->priv->window_clone_container;
#line 136 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp73_, "requested-close", (GCallback) ______lambda146__gala_window_clone_container_requested_close, self, 0);
#line 137 "../src/Widgets/WindowOverview.vala"
				_tmp74_ = self->priv->window_clone_container;
#line 137 "../src/Widgets/WindowOverview.vala"
				g_signal_connect_object (_tmp74_, "last-window-closed", (GCallback) ______lambda147__gala_window_clone_container_last_window_closed, self, 0);
#line 139 "../src/Widgets/WindowOverview.vala"
				_tmp75_ = self->priv->window_clone_container;
#line 139 "../src/Widgets/WindowOverview.vala"
				clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp75_);
#line 1122 "WindowOverview.c"
			}
		}
	}
#line 142 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 144 "../src/Widgets/WindowOverview.vala"
	_tmp76_ = windows;
#line 1130 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 144 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp76_;
#line 144 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1138 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 144 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1142 "WindowOverview.c"
			{
				MetaWindowActor* actor = NULL;
				MetaWindow* _tmp77_;
				GObject* _tmp78_;
				MetaWindowActor* _tmp79_;
				GalaWindowCloneContainer* container = NULL;
				MetaWindow* _tmp80_;
				ClutterActor* _tmp81_;
				GalaWindowCloneContainer* _tmp82_;
				GalaWindowCloneContainer* _tmp83_;
				MetaWindow* _tmp84_;
#line 145 "../src/Widgets/WindowOverview.vala"
				_tmp77_ = window;
#line 145 "../src/Widgets/WindowOverview.vala"
				_tmp78_ = meta_window_get_compositor_private (_tmp77_);
#line 145 "../src/Widgets/WindowOverview.vala"
				actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, meta_window_actor_get_type (), MetaWindowActor);
#line 146 "../src/Widgets/WindowOverview.vala"
				_tmp79_ = actor;
#line 146 "../src/Widgets/WindowOverview.vala"
				clutter_actor_hide ((ClutterActor*) _tmp79_);
#line 148 "../src/Widgets/WindowOverview.vala"
				_tmp80_ = window;
#line 148 "../src/Widgets/WindowOverview.vala"
				_tmp81_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (_tmp80_));
#line 148 "../src/Widgets/WindowOverview.vala"
				container = G_TYPE_CHECK_INSTANCE_CAST (_tmp81_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 149 "../src/Widgets/WindowOverview.vala"
				_tmp82_ = container;
#line 149 "../src/Widgets/WindowOverview.vala"
				if (_tmp82_ == NULL) {
#line 150 "../src/Widgets/WindowOverview.vala"
					continue;
#line 1176 "WindowOverview.c"
				}
#line 153 "../src/Widgets/WindowOverview.vala"
				_tmp83_ = container;
#line 153 "../src/Widgets/WindowOverview.vala"
				_tmp84_ = window;
#line 153 "../src/Widgets/WindowOverview.vala"
				gala_window_clone_container_add_window (_tmp83_, _tmp84_);
#line 1184 "WindowOverview.c"
			}
		}
	}
#line 156 "../src/Widgets/WindowOverview.vala"
	_tmp85_ = self->priv->gesture_controller;
#line 156 "../src/Widgets/WindowOverview.vala"
	gala_gesture_controller_goto (_tmp85_, (gdouble) 1);
#line 62 "../src/Widgets/WindowOverview.vala"
	(windows == NULL) ? NULL : (windows = (_g_list_free__g_object_unref0_ (windows), NULL));
#line 62 "../src/Widgets/WindowOverview.vala"
	window_ids = (g_free (window_ids), NULL);
#line 1196 "WindowOverview.c"
}

static gboolean
gala_window_overview_keybinding_filter (GalaWindowOverview* self,
                                        MetaKeyBinding* binding)
{
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 170 "../src/Widgets/WindowOverview.vala"
	static GQuark _tmp3_label0 = 0;
#line 1210 "WindowOverview.c"
	gboolean result;
#line 159 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 160 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 160 "../src/Widgets/WindowOverview.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 162 "../src/Widgets/WindowOverview.vala"
	switch (action) {
#line 162 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_NONE:
#line 162 "../src/Widgets/WindowOverview.vala"
		case META_KEYBINDING_ACTION_LOCATE_POINTER_KEY:
#line 1226 "WindowOverview.c"
		{
#line 165 "../src/Widgets/WindowOverview.vala"
			result = FALSE;
#line 165 "../src/Widgets/WindowOverview.vala"
			return result;
#line 1232 "WindowOverview.c"
		}
		default:
		{
#line 167 "../src/Widgets/WindowOverview.vala"
			break;
#line 1238 "WindowOverview.c"
		}
	}
#line 170 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 170 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = _tmp1_;
#line 170 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 170 "../src/Widgets/WindowOverview.vala"
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("expose-all-windows")))) {
#line 170 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1251 "WindowOverview.c"
			default:
			{
#line 172 "../src/Widgets/WindowOverview.vala"
				result = FALSE;
#line 172 "../src/Widgets/WindowOverview.vala"
				return result;
#line 1258 "WindowOverview.c"
			}
		}
	} else {
#line 170 "../src/Widgets/WindowOverview.vala"
		switch (0) {
#line 1264 "WindowOverview.c"
			default:
			{
#line 174 "../src/Widgets/WindowOverview.vala"
				break;
#line 1269 "WindowOverview.c"
			}
		}
	}
#line 177 "../src/Widgets/WindowOverview.vala"
	result = TRUE;
#line 177 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1277 "WindowOverview.c"
}

static void
gala_window_overview_window_left_monitor (GalaWindowOverview* self,
                                          gint num,
                                          MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GList* _tmp2_;
#line 180 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 181 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, num);
#line 181 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 182 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 182 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 183 "../src/Widgets/WindowOverview.vala"
		return;
#line 1303 "WindowOverview.c"
	}
#line 187 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1307 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 187 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 187 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1315 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 187 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 187 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1322 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
#line 188 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 188 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp4_)) {
#line 1329 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp5_;
#line 189 "../src/Widgets/WindowOverview.vala"
					_tmp5_ = container;
#line 189 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_remove_window (_tmp5_, window);
#line 190 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 190 "../src/Widgets/WindowOverview.vala"
					break;
#line 1339 "WindowOverview.c"
				}
#line 187 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1343 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_add_window (GalaWindowOverview* self,
                                 MetaWindow* window)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaWindowType _tmp3_;
	MetaWindowType _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	MetaWindowType _tmp7_;
	MetaWindowType _tmp8_;
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp13_;
	GalaWindowCloneContainer* _tmp14_;
	GList* _tmp15_;
#line 195 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 196 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 196 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 196 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 197 "../src/Widgets/WindowOverview.vala"
		return;
#line 1378 "WindowOverview.c"
	}
#line 199 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_window_get_window_type (window);
#line 199 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = _tmp3_;
#line 199 "../src/Widgets/WindowOverview.vala"
	if (_tmp4_ == META_WINDOW_DOCK) {
#line 199 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = TRUE;
#line 1388 "WindowOverview.c"
	} else {
#line 199 "../src/Widgets/WindowOverview.vala"
		_tmp2_ = gala_notification_stack_is_notification (window);
#line 1392 "WindowOverview.c"
	}
#line 199 "../src/Widgets/WindowOverview.vala"
	if (_tmp2_) {
#line 200 "../src/Widgets/WindowOverview.vala"
		return;
#line 1398 "WindowOverview.c"
	}
#line 202 "../src/Widgets/WindowOverview.vala"
	_tmp7_ = meta_window_get_window_type (window);
#line 202 "../src/Widgets/WindowOverview.vala"
	_tmp8_ = _tmp7_;
#line 202 "../src/Widgets/WindowOverview.vala"
	if (_tmp8_ != META_WINDOW_NORMAL) {
#line 1406 "WindowOverview.c"
		MetaWindowType _tmp9_;
		MetaWindowType _tmp10_;
#line 203 "../src/Widgets/WindowOverview.vala"
		_tmp9_ = meta_window_get_window_type (window);
#line 203 "../src/Widgets/WindowOverview.vala"
		_tmp10_ = _tmp9_;
#line 203 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = _tmp10_ != META_WINDOW_DIALOG;
#line 1415 "WindowOverview.c"
	} else {
#line 202 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = FALSE;
#line 1419 "WindowOverview.c"
	}
#line 202 "../src/Widgets/WindowOverview.vala"
	if (_tmp6_) {
#line 202 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = TRUE;
#line 1425 "WindowOverview.c"
	} else {
#line 204 "../src/Widgets/WindowOverview.vala"
		_tmp5_ = meta_window_is_attached_dialog (window);
#line 1429 "WindowOverview.c"
	}
#line 202 "../src/Widgets/WindowOverview.vala"
	if (_tmp5_) {
#line 1433 "WindowOverview.c"
		MetaWindowActor* actor = NULL;
		GObject* _tmp11_;
		MetaWindowActor* _tmp12_;
#line 205 "../src/Widgets/WindowOverview.vala"
		_tmp11_ = meta_window_get_compositor_private (window);
#line 205 "../src/Widgets/WindowOverview.vala"
		actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, meta_window_actor_get_type (), MetaWindowActor);
#line 206 "../src/Widgets/WindowOverview.vala"
		_tmp12_ = actor;
#line 206 "../src/Widgets/WindowOverview.vala"
		clutter_actor_hide ((ClutterActor*) _tmp12_);
#line 208 "../src/Widgets/WindowOverview.vala"
		return;
#line 1447 "WindowOverview.c"
	}
#line 211 "../src/Widgets/WindowOverview.vala"
	_tmp13_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 211 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 212 "../src/Widgets/WindowOverview.vala"
	_tmp14_ = container;
#line 212 "../src/Widgets/WindowOverview.vala"
	if (_tmp14_ == NULL) {
#line 213 "../src/Widgets/WindowOverview.vala"
		return;
#line 1459 "WindowOverview.c"
	}
#line 217 "../src/Widgets/WindowOverview.vala"
	_tmp15_ = self->priv->workspaces;
#line 1463 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 217 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp15_;
#line 217 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1471 "WindowOverview.c"
			MetaWorkspace* _tmp16_;
			MetaWorkspace* workspace = NULL;
#line 217 "../src/Widgets/WindowOverview.vala"
			_tmp16_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 217 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp16_;
#line 1478 "WindowOverview.c"
			{
				MetaWorkspace* _tmp17_;
#line 218 "../src/Widgets/WindowOverview.vala"
				_tmp17_ = workspace;
#line 218 "../src/Widgets/WindowOverview.vala"
				if (meta_window_located_on_workspace (window, _tmp17_)) {
#line 1485 "WindowOverview.c"
					GalaWindowCloneContainer* _tmp18_;
#line 219 "../src/Widgets/WindowOverview.vala"
					_tmp18_ = container;
#line 219 "../src/Widgets/WindowOverview.vala"
					gala_window_clone_container_add_window (_tmp18_, window);
#line 220 "../src/Widgets/WindowOverview.vala"
					_g_object_unref0 (workspace);
#line 220 "../src/Widgets/WindowOverview.vala"
					break;
#line 1495 "WindowOverview.c"
				}
#line 217 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1499 "WindowOverview.c"
			}
		}
	}
}

static void
gala_window_overview_remove_window (GalaWindowOverview* self,
                                    MetaWindow* window)
{
	GalaWindowCloneContainer* container = NULL;
	ClutterActor* _tmp0_;
	GalaWindowCloneContainer* _tmp1_;
	GalaWindowCloneContainer* _tmp2_;
#line 225 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 226 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = clutter_actor_get_child_at_index ((ClutterActor*) self, meta_window_get_monitor (window));
#line 226 "../src/Widgets/WindowOverview.vala"
	container = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GALA_TYPE_WINDOW_CLONE_CONTAINER, GalaWindowCloneContainer);
#line 227 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = container;
#line 227 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == NULL) {
#line 228 "../src/Widgets/WindowOverview.vala"
		return;
#line 1527 "WindowOverview.c"
	}
#line 231 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = container;
#line 231 "../src/Widgets/WindowOverview.vala"
	gala_window_clone_container_remove_window (_tmp2_, window);
#line 1533 "WindowOverview.c"
}

static Block65Data*
block65_data_ref (Block65Data* _data65_)
{
#line 234 "../src/Widgets/WindowOverview.vala"
	g_atomic_int_inc (&_data65_->_ref_count_);
#line 234 "../src/Widgets/WindowOverview.vala"
	return _data65_;
#line 1543 "WindowOverview.c"
}

static void
block65_data_unref (void * _userdata_)
{
	Block65Data* _data65_;
	_data65_ = (Block65Data*) _userdata_;
#line 234 "../src/Widgets/WindowOverview.vala"
	if (g_atomic_int_dec_and_test (&_data65_->_ref_count_)) {
#line 1553 "WindowOverview.c"
		GalaWindowOverview* self;
#line 234 "../src/Widgets/WindowOverview.vala"
		self = _data65_->self;
#line 234 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (_data65_->window);
#line 234 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self);
#line 234 "../src/Widgets/WindowOverview.vala"
		g_slice_free (Block65Data, _data65_);
#line 1563 "WindowOverview.c"
	}
}

static gboolean
___lambda145_ (Block65Data* _data65_)
{
	GalaWindowOverview* self;
	MetaWorkspace* _tmp0_;
	MetaDisplay* _tmp1_;
	gboolean result;
#line 242 "../src/Widgets/WindowOverview.vala"
	self = _data65_->self;
#line 243 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = meta_window_get_workspace (_data65_->window);
#line 243 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_display (_data65_->window);
#line 243 "../src/Widgets/WindowOverview.vala"
	meta_workspace_activate_with_focus (_tmp0_, _data65_->window, meta_display_get_current_time (_tmp1_));
#line 244 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 244 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1586 "WindowOverview.c"
}

static gboolean
____lambda145__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda145_ (self);
#line 242 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1596 "WindowOverview.c"
}

static void
gala_window_overview_thumb_selected (GalaWindowOverview* self,
                                     MetaWindow* window)
{
	Block65Data* _data65_;
	MetaWindow* _tmp0_;
	MetaWorkspace* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
#line 234 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (window != NULL);
#line 234 "../src/Widgets/WindowOverview.vala"
	_data65_ = g_slice_new0 (Block65Data);
#line 234 "../src/Widgets/WindowOverview.vala"
	_data65_->_ref_count_ = 1;
#line 234 "../src/Widgets/WindowOverview.vala"
	_data65_->self = g_object_ref (self);
#line 234 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 234 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (_data65_->window);
#line 234 "../src/Widgets/WindowOverview.vala"
	_data65_->window = _tmp0_;
#line 235 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = meta_window_get_workspace (_data65_->window);
#line 235 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 235 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 235 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 235 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 235 "../src/Widgets/WindowOverview.vala"
	if (_tmp1_ == _tmp5_) {
#line 1638 "WindowOverview.c"
		MetaDisplay* _tmp6_;
#line 236 "../src/Widgets/WindowOverview.vala"
		_tmp6_ = meta_window_get_display (_data65_->window);
#line 236 "../src/Widgets/WindowOverview.vala"
		meta_window_activate (_data65_->window, meta_display_get_current_time (_tmp6_));
#line 237 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 1646 "WindowOverview.c"
	} else {
#line 239 "../src/Widgets/WindowOverview.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) self, NULL);
#line 242 "../src/Widgets/WindowOverview.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ____lambda145__gsource_func, block65_data_ref (_data65_), block65_data_unref);
#line 1652 "WindowOverview.c"
	}
#line 234 "../src/Widgets/WindowOverview.vala"
	block65_data_unref (_data65_);
#line 234 "../src/Widgets/WindowOverview.vala"
	_data65_ = NULL;
#line 1658 "WindowOverview.c"
}

/**
     * {@inheritDoc}
     */
static gboolean
__lambda144_ (GalaWindowOverview* self)
{
	gboolean result;
#line 268 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_cleanup (self);
#line 270 "../src/Widgets/WindowOverview.vala"
	result = G_SOURCE_REMOVE;
#line 270 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1674 "WindowOverview.c"
}

static gboolean
___lambda144__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda144_ ((GalaWindowOverview*) self);
#line 264 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1684 "WindowOverview.c"
}

static void
gala_window_overview_real_close (GalaActivatableComponent* base,
                                 GHashTable* hints)
{
	GalaWindowOverview * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GList* _tmp2_;
	GalaWindowManager* _tmp8_;
	MetaDisplay* _tmp9_;
	guint _tmp10_;
	GalaGestureController* _tmp11_;
#line 252 "../src/Widgets/WindowOverview.vala"
	self = (GalaWindowOverview*) base;
#line 253 "../src/Widgets/WindowOverview.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp0_, NULL);
#line 253 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = _tmp0_;
#line 253 "../src/Widgets/WindowOverview.vala"
	if (!_tmp1_) {
#line 254 "../src/Widgets/WindowOverview.vala"
		return;
#line 1709 "WindowOverview.c"
	}
#line 257 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->workspaces;
#line 1713 "WindowOverview.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 257 "../src/Widgets/WindowOverview.vala"
		workspace_collection = _tmp2_;
#line 257 "../src/Widgets/WindowOverview.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1721 "WindowOverview.c"
			MetaWorkspace* _tmp3_;
			MetaWorkspace* workspace = NULL;
#line 257 "../src/Widgets/WindowOverview.vala"
			_tmp3_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 257 "../src/Widgets/WindowOverview.vala"
			workspace = _tmp3_;
#line 1728 "WindowOverview.c"
			{
				MetaWorkspace* _tmp4_;
				guint _tmp5_;
				MetaWorkspace* _tmp6_;
				guint _tmp7_;
#line 258 "../src/Widgets/WindowOverview.vala"
				_tmp4_ = workspace;
#line 258 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp5_, NULL, FALSE);
#line 258 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_window_overview_add_window_meta_workspace_window_added, self);
#line 259 "../src/Widgets/WindowOverview.vala"
				_tmp6_ = workspace;
#line 259 "../src/Widgets/WindowOverview.vala"
				g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp7_, NULL, FALSE);
#line 259 "../src/Widgets/WindowOverview.vala"
				g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_window_overview_remove_window_meta_workspace_window_removed, self);
#line 257 "../src/Widgets/WindowOverview.vala"
				_g_object_unref0 (workspace);
#line 1748 "WindowOverview.c"
			}
		}
	}
#line 261 "../src/Widgets/WindowOverview.vala"
	_tmp8_ = self->priv->_wm;
#line 261 "../src/Widgets/WindowOverview.vala"
	_tmp9_ = meta_plugin_get_display ((MetaPlugin*) _tmp8_);
#line 261 "../src/Widgets/WindowOverview.vala"
	g_signal_parse_name ("window-left-monitor", meta_display_get_type (), &_tmp10_, NULL, FALSE);
#line 261 "../src/Widgets/WindowOverview.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _gala_window_overview_window_left_monitor_meta_display_window_left_monitor, self);
#line 264 "../src/Widgets/WindowOverview.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GALA_MULTITASKING_VIEW_ANIMATION_DURATION, ___lambda144__gsource_func, g_object_ref (self), g_object_unref);
#line 273 "../src/Widgets/WindowOverview.vala"
	_tmp11_ = self->priv->gesture_controller;
#line 273 "../src/Widgets/WindowOverview.vala"
	gala_gesture_controller_goto (_tmp11_, (gdouble) 0);
#line 1766 "WindowOverview.c"
}

static void
gala_window_overview_cleanup (GalaWindowOverview* self)
{
	GalaWindowManager* _tmp0_;
	GalaModalProxy* _tmp1_;
	GalaWindowManager* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspace* _tmp5_;
	GList* _tmp6_;
#line 276 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 277 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 279 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 279 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = self->priv->modal_proxy;
#line 279 "../src/Widgets/WindowOverview.vala"
	gala_window_manager_pop_modal (_tmp0_, _tmp1_);
#line 281 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->_wm;
#line 281 "../src/Widgets/WindowOverview.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) _tmp2_);
#line 281 "../src/Widgets/WindowOverview.vala"
	_tmp4_ = meta_display_get_workspace_manager (_tmp3_);
#line 281 "../src/Widgets/WindowOverview.vala"
	_tmp5_ = meta_workspace_manager_get_active_workspace (_tmp4_);
#line 281 "../src/Widgets/WindowOverview.vala"
	_tmp6_ = meta_workspace_list_windows (_tmp5_);
#line 1799 "WindowOverview.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 281 "../src/Widgets/WindowOverview.vala"
		window_collection = _tmp6_;
#line 281 "../src/Widgets/WindowOverview.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1807 "WindowOverview.c"
			MetaWindow* window = NULL;
#line 281 "../src/Widgets/WindowOverview.vala"
			window = (MetaWindow*) window_it->data;
#line 1811 "WindowOverview.c"
			{
				MetaWindow* _tmp7_;
#line 282 "../src/Widgets/WindowOverview.vala"
				_tmp7_ = window;
#line 282 "../src/Widgets/WindowOverview.vala"
				if (meta_window_showing_on_its_workspace (_tmp7_)) {
#line 1818 "WindowOverview.c"
					MetaWindow* _tmp8_;
					GObject* _tmp9_;
#line 283 "../src/Widgets/WindowOverview.vala"
					_tmp8_ = window;
#line 283 "../src/Widgets/WindowOverview.vala"
					_tmp9_ = meta_window_get_compositor_private (_tmp8_);
#line 283 "../src/Widgets/WindowOverview.vala"
					clutter_actor_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, clutter_actor_get_type (), ClutterActor));
#line 1827 "WindowOverview.c"
				}
			}
		}
#line 281 "../src/Widgets/WindowOverview.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1833 "WindowOverview.c"
	}
#line 287 "../src/Widgets/WindowOverview.vala"
	clutter_actor_destroy_all_children ((ClutterActor*) self);
#line 1837 "WindowOverview.c"
}

GalaWindowManager*
gala_window_overview_get_wm (GalaWindowOverview* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 13 "../src/Widgets/WindowOverview.vala"
	result = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
	return result;
#line 1853 "WindowOverview.c"
}

static void
gala_window_overview_set_wm (GalaWindowOverview* self,
                             GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 13 "../src/Widgets/WindowOverview.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/Widgets/WindowOverview.vala"
	old_value = gala_window_overview_get_wm (self);
#line 13 "../src/Widgets/WindowOverview.vala"
	if (old_value != value) {
#line 1867 "WindowOverview.c"
		GalaWindowManager* _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 13 "../src/Widgets/WindowOverview.vala"
		_g_object_unref0 (self->priv->_wm);
#line 13 "../src/Widgets/WindowOverview.vala"
		self->priv->_wm = _tmp0_;
#line 13 "../src/Widgets/WindowOverview.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY]);
#line 1877 "WindowOverview.c"
	}
}

static GObject *
gala_window_overview_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowOverview * self;
	GalaWindowManager* _tmp0_;
	GalaGestureController* _tmp1_ = NULL;
	GalaGestureController* _tmp2_;
#line 26 "../src/Widgets/WindowOverview.vala"
	parent_class = G_OBJECT_CLASS (gala_window_overview_parent_class);
#line 26 "../src/Widgets/WindowOverview.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 26 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 27 "../src/Widgets/WindowOverview.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 28 "../src/Widgets/WindowOverview.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 29 "../src/Widgets/WindowOverview.vala"
	_tmp0_ = self->priv->_wm;
#line 29 "../src/Widgets/WindowOverview.vala"
	_tmp1_ = gala_gesture_controller_new (GALA_GESTURE_ACTION_MULTITASKING_VIEW, _tmp0_);
#line 29 "../src/Widgets/WindowOverview.vala"
	gala_gesture_controller_set_enabled (_tmp1_, FALSE);
#line 29 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->gesture_controller);
#line 29 "../src/Widgets/WindowOverview.vala"
	self->priv->gesture_controller = _tmp1_;
#line 32 "../src/Widgets/WindowOverview.vala"
	_tmp2_ = self->priv->gesture_controller;
#line 32 "../src/Widgets/WindowOverview.vala"
	gala_root_target_add_gesture_controller ((GalaRootTarget*) self, _tmp2_);
#line 26 "../src/Widgets/WindowOverview.vala"
	return obj;
#line 1918 "WindowOverview.c"
}

static void
gala_window_overview_class_init (GalaWindowOverviewClass * klass,
                                 gpointer klass_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Widgets/WindowOverview.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowOverview_private_offset);
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_key_press_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	((ClutterActorClass *) klass)->button_release_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_window_overview_real_button_release_event;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_overview_get_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_overview_set_property;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_overview_constructor;
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_overview_finalize;
#line 8 "../src/Widgets/WindowOverview.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_OVERVIEW_WM_PROPERTY, gala_window_overview_properties[GALA_WINDOW_OVERVIEW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1943 "WindowOverview.c"
}

static void
gala_window_overview_gala_root_target_interface_init (GalaRootTargetIface * iface,
                                                      gpointer iface_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_gala_root_target_parent_iface = g_type_interface_peek_parent (iface);
#line 1952 "WindowOverview.c"
}

static void
gala_window_overview_gala_activatable_component_interface_init (GalaActivatableComponentIface * iface,
                                                                gpointer iface_data)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	gala_window_overview_gala_activatable_component_parent_iface = g_type_interface_peek_parent (iface);
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->is_opened = (gboolean (*) (GalaActivatableComponent*)) gala_window_overview_real_is_opened;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->open = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_open;
#line 8 "../src/Widgets/WindowOverview.vala"
	iface->close = (void (*) (GalaActivatableComponent*, GHashTable*)) gala_window_overview_real_close;
#line 1967 "WindowOverview.c"
}

static void
gala_window_overview_instance_init (GalaWindowOverview * self,
                                    gpointer klass)
{
#line 8 "../src/Widgets/WindowOverview.vala"
	self->priv = gala_window_overview_get_instance_private (self);
#line 1976 "WindowOverview.c"
}

static void
gala_window_overview_finalize (GObject * obj)
{
	GalaWindowOverview * self;
#line 8 "../src/Widgets/WindowOverview.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 13 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->_wm);
#line 15 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->gesture_controller);
#line 17 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 19 "../src/Widgets/WindowOverview.vala"
	(self->priv->workspaces == NULL) ? NULL : (self->priv->workspaces = (_g_list_free__g_object_unref0_ (self->priv->workspaces), NULL));
#line 20 "../src/Widgets/WindowOverview.vala"
	_g_object_unref0 (self->priv->window_clone_container);
#line 8 "../src/Widgets/WindowOverview.vala"
	G_OBJECT_CLASS (gala_window_overview_parent_class)->finalize (obj);
#line 1997 "WindowOverview.c"
}

 G_GNUC_NO_INLINE static GType
gala_window_overview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowOverviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_overview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowOverview), 0, (GInstanceInitFunc) gala_window_overview_instance_init, NULL };
	static const GInterfaceInfo gala_root_target_info = { (GInterfaceInitFunc) gala_window_overview_gala_root_target_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gala_activatable_component_info = { (GInterfaceInitFunc) gala_window_overview_gala_activatable_component_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_overview_type_id;
	gala_window_overview_type_id = g_type_register_static (GALA_TYPE_ACTOR_TARGET, "GalaWindowOverview", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_overview_type_id, GALA_TYPE_ROOT_TARGET, &gala_root_target_info);
	g_type_add_interface_static (gala_window_overview_type_id, GALA_TYPE_ACTIVATABLE_COMPONENT, &gala_activatable_component_info);
	GalaWindowOverview_private_offset = g_type_add_instance_private (gala_window_overview_type_id, sizeof (GalaWindowOverviewPrivate));
	return gala_window_overview_type_id;
}

GType
gala_window_overview_get_type (void)
{
	static gsize gala_window_overview_type_id__once = 0;
	if (g_once_init_enter (&gala_window_overview_type_id__once)) {
		GType gala_window_overview_type_id;
		gala_window_overview_type_id = gala_window_overview_get_type_once ();
		g_once_init_leave (&gala_window_overview_type_id__once, gala_window_overview_type_id);
	}
	return gala_window_overview_type_id__once;
}

static void
_vala_gala_window_overview_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		g_value_set_object (value, gala_window_overview_get_wm (self));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2042 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2048 "WindowOverview.c"
	}
}

static void
_vala_gala_window_overview_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GalaWindowOverview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview);
#line 8 "../src/Widgets/WindowOverview.vala"
	switch (property_id) {
#line 8 "../src/Widgets/WindowOverview.vala"
		case GALA_WINDOW_OVERVIEW_WM_PROPERTY:
#line 8 "../src/Widgets/WindowOverview.vala"
		gala_window_overview_set_wm (self, g_value_get_object (value));
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2068 "WindowOverview.c"
		default:
#line 8 "../src/Widgets/WindowOverview.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/Widgets/WindowOverview.vala"
		break;
#line 2074 "WindowOverview.c"
	}
}

