/* WorkspaceManager.c generated by valac 0.56.18, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/*
 * Copyright 2014 Tom Beckmann, Rico Tzschichholz
 * Copyright 2025 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include "gala.h"
#include <glib.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <meta/window.h>
#include <meta/display.h>
#include <meta/prefs.h>
#include <meta/types.h>
#include <meta/meta-plugin.h>
#include <meta/compositor.h>
#include <meta/util.h>
#include <meta/meta-startup-notification.h>
#include <meta/meta-window-actor.h>
#include <meta/common.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_0_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM_PROPERTY,
	GALA_WORKSPACE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	gint remove_freeze_count;
	guint check_workspaces_id;
};

static gint GalaWorkspaceManager_private_offset;
static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

VALA_EXTERN GType gala_workspace_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWorkspaceManager, g_object_unref)
VALA_EXTERN void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type,
                                                        GalaWindowManager* wm);
VALA_EXTERN GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                             MetaWorkspaceManager* manager,
                                             gint index);
static void gala_workspace_manager_queue_check_workspaces (GalaWorkspaceManager* self);
static void _gala_workspace_manager_queue_check_workspaces_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                                 MetaWindow* object,
                                                                                 gpointer self);
static void _gala_workspace_manager_queue_check_workspaces_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                                   MetaWindow* object,
                                                                                   gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                                    MetaDisplay* display,
                                                    gint monitor,
                                                    MetaWindow* window);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                                 MetaDisplay* display,
                                                 gint monitor,
                                                 MetaWindow* window);
VALA_EXTERN void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
VALA_EXTERN void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
VALA_EXTERN GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static gboolean gala_workspace_manager_check_workspaces (GalaWorkspaceManager* self);
static gboolean _gala_workspace_manager_check_workspaces_gsource_func (gpointer self);
static void _vala_array_add10 (gboolean* * array,
                        gint* length,
                        gint* size,
                        gboolean value);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                                    GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _gala_workspace_manager_queue_check_workspaces_meta_workspace_manager_workspace_switched (MetaWorkspaceManager* _sender,
                                                                                               gint object,
                                                                                               gint p0,
                                                                                               MetaMotionDirection p1,
                                                                                               gpointer self);
static void _gala_workspace_manager_workspace_added_meta_workspace_manager_workspace_added (MetaWorkspaceManager* _sender,
                                                                                     gint object,
                                                                                     gpointer self);
static void _gala_workspace_manager_window_entered_monitor_meta_display_window_entered_monitor (MetaDisplay* _sender,
                                                                                         gint object,
                                                                                         MetaWindow* p0,
                                                                                         gpointer self);
static void _gala_workspace_manager_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                                   gint object,
                                                                                   MetaWindow* p0,
                                                                                   gpointer self);
static void gala_workspace_manager_finalize (GObject * obj);
static GType gala_workspace_manager_get_type_once (void);
static void _vala_gala_workspace_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
gala_workspace_manager_get_instance_private (GalaWorkspaceManager* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWorkspaceManager_private_offset);
}

void
gala_workspace_manager_init (GalaWindowManager* wm)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 8 "../src/WorkspaceManager.vala"
	g_return_if_fail (wm != NULL);
#line 8 "../src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 8 "../src/WorkspaceManager.vala"
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
#line 9 "../src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_new (wm);
#line 9 "../src/WorkspaceManager.vala"
	_g_object_unref0 (gala_workspace_manager_instance);
#line 9 "../src/WorkspaceManager.vala"
	gala_workspace_manager_instance = _tmp1_;
#line 176 "WorkspaceManager.c"
}

GalaWorkspaceManager*
gala_workspace_manager_get_default (void)
{
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
	GalaWorkspaceManager* result;
#line 12 "../src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 12 "../src/WorkspaceManager.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
#line 13 "../src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_instance;
#line 13 "../src/WorkspaceManager.vala"
	result = _tmp1_;
#line 13 "../src/WorkspaceManager.vala"
	return result;
#line 195 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_construct (GType object_type,
                                  GalaWindowManager* wm)
{
	GalaWorkspaceManager * self = NULL;
#line 23 "../src/WorkspaceManager.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 24 "../src/WorkspaceManager.vala"
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", wm, NULL);
#line 23 "../src/WorkspaceManager.vala"
	return self;
#line 209 "WorkspaceManager.c"
}

static GalaWorkspaceManager*
gala_workspace_manager_new (GalaWindowManager* wm)
{
#line 23 "../src/WorkspaceManager.vala"
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
#line 217 "WorkspaceManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/WorkspaceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 225 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_queue_check_workspaces_meta_workspace_window_added (MetaWorkspace* _sender,
                                                                            MetaWindow* object,
                                                                            gpointer self)
{
#line 49 "../src/WorkspaceManager.vala"
	gala_workspace_manager_queue_check_workspaces ((GalaWorkspaceManager*) self);
#line 235 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_queue_check_workspaces_meta_workspace_window_removed (MetaWorkspace* _sender,
                                                                              MetaWindow* object,
                                                                              gpointer self)
{
#line 50 "../src/WorkspaceManager.vala"
	gala_workspace_manager_queue_check_workspaces ((GalaWorkspaceManager*) self);
#line 245 "WorkspaceManager.c"
}

static void
gala_workspace_manager_workspace_added (GalaWorkspaceManager* self,
                                        MetaWorkspaceManager* manager,
                                        gint index)
{
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
#line 43 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/WorkspaceManager.vala"
	g_return_if_fail (manager != NULL);
#line 44 "../src/WorkspaceManager.vala"
	_tmp0_ = meta_workspace_manager_get_workspace_by_index (manager, index);
#line 44 "../src/WorkspaceManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 44 "../src/WorkspaceManager.vala"
	workspace = _tmp1_;
#line 45 "../src/WorkspaceManager.vala"
	_tmp2_ = workspace;
#line 45 "../src/WorkspaceManager.vala"
	if (_tmp2_ == NULL) {
#line 46 "../src/WorkspaceManager.vala"
		_g_object_unref0 (workspace);
#line 46 "../src/WorkspaceManager.vala"
		return;
#line 277 "WorkspaceManager.c"
	}
#line 49 "../src/WorkspaceManager.vala"
	_tmp3_ = workspace;
#line 49 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp3_, "window-added", (GCallback) _gala_workspace_manager_queue_check_workspaces_meta_workspace_window_added, self, 0);
#line 50 "../src/WorkspaceManager.vala"
	_tmp4_ = workspace;
#line 50 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp4_, "window-removed", (GCallback) _gala_workspace_manager_queue_check_workspaces_meta_workspace_window_removed, self, 0);
#line 43 "../src/WorkspaceManager.vala"
	_g_object_unref0 (workspace);
#line 289 "WorkspaceManager.c"
}

static void
gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self,
                                               MetaDisplay* display,
                                               gint monitor,
                                               MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 53 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/WorkspaceManager.vala"
	g_return_if_fail (display != NULL);
#line 53 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 54 "../src/WorkspaceManager.vala"
	if (meta_prefs_get_workspaces_only_on_primary ()) {
#line 54 "../src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_display_get_primary_monitor (display);
#line 309 "WorkspaceManager.c"
	} else {
#line 54 "../src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 313 "WorkspaceManager.c"
	}
#line 54 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 55 "../src/WorkspaceManager.vala"
		gala_workspace_manager_queue_check_workspaces (self);
#line 319 "WorkspaceManager.c"
	}
}

static void
gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self,
                                            MetaDisplay* display,
                                            gint monitor,
                                            MetaWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 59 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/WorkspaceManager.vala"
	g_return_if_fail (display != NULL);
#line 59 "../src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 60 "../src/WorkspaceManager.vala"
	if (meta_prefs_get_workspaces_only_on_primary ()) {
#line 60 "../src/WorkspaceManager.vala"
		_tmp0_ = monitor == meta_display_get_primary_monitor (display);
#line 340 "WorkspaceManager.c"
	} else {
#line 60 "../src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 344 "WorkspaceManager.c"
	}
#line 60 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 61 "../src/WorkspaceManager.vala"
		gala_workspace_manager_queue_check_workspaces (self);
#line 350 "WorkspaceManager.c"
	}
}

/**
     * Temporarily disables removing workspaces when they are empty
     */
void
gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self)
{
#line 68 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/WorkspaceManager.vala"
	g_atomic_int_inc (&self->priv->remove_freeze_count);
#line 364 "WorkspaceManager.c"
}

/**
     * Undo the effect of freeze_remove()
     */
void
gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self)
{
	gboolean _tmp0_;
#line 75 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/WorkspaceManager.vala"
	_tmp0_ = g_atomic_int_dec_and_test (&self->priv->remove_freeze_count);
#line 76 "../src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 77 "../src/WorkspaceManager.vala"
		gala_workspace_manager_queue_check_workspaces (self);
#line 382 "WorkspaceManager.c"
	}
#line 80 "../src/WorkspaceManager.vala"
	_vala_assert (self->priv->remove_freeze_count >= 0, "remove_freeze_count >= 0");
#line 386 "WorkspaceManager.c"
}

static gboolean
_gala_workspace_manager_check_workspaces_gsource_func (gpointer self)
{
	gboolean result;
	result = gala_workspace_manager_check_workspaces ((GalaWorkspaceManager*) self);
#line 86 "../src/WorkspaceManager.vala"
	return result;
#line 396 "WorkspaceManager.c"
}

static void
gala_workspace_manager_queue_check_workspaces (GalaWorkspaceManager* self)
{
#line 83 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/WorkspaceManager.vala"
	if (self->priv->check_workspaces_id == ((guint) 0)) {
#line 406 "WorkspaceManager.c"
		MetaLaters* laters = NULL;
		GalaWindowManager* _tmp0_;
		MetaDisplay* _tmp1_;
		MetaCompositor* _tmp2_;
		MetaLaters* _tmp3_;
		MetaLaters* _tmp4_;
		MetaLaters* _tmp5_;
#line 85 "../src/WorkspaceManager.vala"
		_tmp0_ = self->priv->_wm;
#line 85 "../src/WorkspaceManager.vala"
		_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 85 "../src/WorkspaceManager.vala"
		_tmp2_ = meta_display_get_compositor (_tmp1_);
#line 85 "../src/WorkspaceManager.vala"
		_tmp3_ = meta_compositor_get_laters (_tmp2_);
#line 85 "../src/WorkspaceManager.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 85 "../src/WorkspaceManager.vala"
		laters = _tmp4_;
#line 86 "../src/WorkspaceManager.vala"
		_tmp5_ = laters;
#line 86 "../src/WorkspaceManager.vala"
		self->priv->check_workspaces_id = meta_laters_add (_tmp5_, META_LATER_BEFORE_REDRAW, _gala_workspace_manager_check_workspaces_gsource_func, g_object_ref (self), g_object_unref);
#line 84 "../src/WorkspaceManager.vala"
		_g_object_unref0 (laters);
#line 432 "WorkspaceManager.c"
	}
}

static void
_vala_array_add10 (gboolean* * array,
                   gint* length,
                   gint* size,
                   gboolean value)
{
#line 130 "../src/WorkspaceManager.vala"
	if ((*length) == (*size)) {
#line 130 "../src/WorkspaceManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 130 "../src/WorkspaceManager.vala"
		*array = g_renew (gboolean, *array, *size);
#line 448 "WorkspaceManager.c"
	}
#line 130 "../src/WorkspaceManager.vala"
	(*array)[(*length)++] = value;
#line 452 "WorkspaceManager.c"
}

static gboolean
gala_workspace_manager_check_workspaces (GalaWorkspaceManager* self)
{
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	gboolean* empty_workspaces = NULL;
	MetaWorkspaceManager* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean* _tmp7_;
	gint empty_workspaces_length1;
	gint _empty_workspaces_size_;
	GSList* active_startup_sequences = NULL;
	MetaDisplay* _tmp12_;
	MetaStartupNotification* _tmp13_;
	GSList* _tmp14_;
	GSList* _tmp15_;
	GList* window_actors = NULL;
	MetaDisplay* _tmp21_;
	MetaCompositor* _tmp22_;
	GList* _tmp23_;
	GList* _tmp24_;
	gboolean* _tmp41_;
	gint _tmp41__length1;
	gboolean* _tmp42_;
	gint _tmp42__length1;
	gboolean _tmp43_;
	gint last_index = 0;
	gboolean* _tmp46_;
	gint _tmp46__length1;
	gint last_empty_index = 0;
	GalaWindowManager* _tmp51_;
	gboolean result;
#line 90 "../src/WorkspaceManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 91 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 91 "../src/WorkspaceManager.vala"
	display = _tmp1_;
#line 92 "../src/WorkspaceManager.vala"
	_tmp2_ = display;
#line 92 "../src/WorkspaceManager.vala"
	_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 92 "../src/WorkspaceManager.vala"
	manager = _tmp3_;
#line 94 "../src/WorkspaceManager.vala"
	if (self->priv->remove_freeze_count > 0) {
#line 95 "../src/WorkspaceManager.vala"
		result = G_SOURCE_CONTINUE;
#line 95 "../src/WorkspaceManager.vala"
		return result;
#line 512 "WorkspaceManager.c"
	}
#line 98 "../src/WorkspaceManager.vala"
	_tmp4_ = manager;
#line 98 "../src/WorkspaceManager.vala"
	_tmp5_ = meta_workspace_manager_get_n_workspaces (_tmp4_);
#line 98 "../src/WorkspaceManager.vala"
	_tmp6_ = _tmp5_;
#line 98 "../src/WorkspaceManager.vala"
	_tmp7_ = g_new0 (gboolean, _tmp6_);
#line 98 "../src/WorkspaceManager.vala"
	empty_workspaces = _tmp7_;
#line 98 "../src/WorkspaceManager.vala"
	empty_workspaces_length1 = _tmp6_;
#line 98 "../src/WorkspaceManager.vala"
	_empty_workspaces_size_ = empty_workspaces_length1;
#line 528 "WorkspaceManager.c"
	{
		gint i = 0;
#line 100 "../src/WorkspaceManager.vala"
		i = 0;
#line 533 "WorkspaceManager.c"
		{
			gboolean _tmp8_ = FALSE;
#line 100 "../src/WorkspaceManager.vala"
			_tmp8_ = TRUE;
#line 100 "../src/WorkspaceManager.vala"
			while (TRUE) {
#line 540 "WorkspaceManager.c"
				gboolean* _tmp10_;
				gint _tmp10__length1;
				gboolean* _tmp11_;
				gint _tmp11__length1;
#line 100 "../src/WorkspaceManager.vala"
				if (!_tmp8_) {
#line 547 "WorkspaceManager.c"
					gint _tmp9_;
#line 100 "../src/WorkspaceManager.vala"
					_tmp9_ = i;
#line 100 "../src/WorkspaceManager.vala"
					i = _tmp9_ + 1;
#line 553 "WorkspaceManager.c"
				}
#line 100 "../src/WorkspaceManager.vala"
				_tmp8_ = FALSE;
#line 100 "../src/WorkspaceManager.vala"
				_tmp10_ = empty_workspaces;
#line 100 "../src/WorkspaceManager.vala"
				_tmp10__length1 = empty_workspaces_length1;
#line 100 "../src/WorkspaceManager.vala"
				if (!(i < _tmp10__length1)) {
#line 100 "../src/WorkspaceManager.vala"
					break;
#line 565 "WorkspaceManager.c"
				}
#line 101 "../src/WorkspaceManager.vala"
				_tmp11_ = empty_workspaces;
#line 101 "../src/WorkspaceManager.vala"
				_tmp11__length1 = empty_workspaces_length1;
#line 101 "../src/WorkspaceManager.vala"
				_tmp11_[i] = TRUE;
#line 573 "WorkspaceManager.c"
			}
		}
	}
#line 104 "../src/WorkspaceManager.vala"
	_tmp12_ = display;
#line 104 "../src/WorkspaceManager.vala"
	_tmp13_ = meta_display_get_startup_notification (_tmp12_);
#line 104 "../src/WorkspaceManager.vala"
	_tmp14_ = meta_startup_notification_get_sequences (_tmp13_);
#line 104 "../src/WorkspaceManager.vala"
	active_startup_sequences = _tmp14_;
#line 105 "../src/WorkspaceManager.vala"
	_tmp15_ = active_startup_sequences;
#line 587 "WorkspaceManager.c"
	{
		GSList* startup_sequence_collection = NULL;
		GSList* startup_sequence_it = NULL;
#line 105 "../src/WorkspaceManager.vala"
		startup_sequence_collection = _tmp15_;
#line 105 "../src/WorkspaceManager.vala"
		for (startup_sequence_it = startup_sequence_collection; startup_sequence_it != NULL; startup_sequence_it = startup_sequence_it->next) {
#line 595 "WorkspaceManager.c"
			MetaStartupSequence* _tmp16_;
			MetaStartupSequence* startup_sequence = NULL;
#line 105 "../src/WorkspaceManager.vala"
			_tmp16_ = _g_object_ref0 ((MetaStartupSequence*) startup_sequence_it->data);
#line 105 "../src/WorkspaceManager.vala"
			startup_sequence = _tmp16_;
#line 602 "WorkspaceManager.c"
			{
				gint index = 0;
				MetaStartupSequence* _tmp17_;
				gboolean _tmp18_ = FALSE;
#line 106 "../src/WorkspaceManager.vala"
				_tmp17_ = startup_sequence;
#line 106 "../src/WorkspaceManager.vala"
				index = meta_startup_sequence_get_workspace (_tmp17_);
#line 107 "../src/WorkspaceManager.vala"
				if (index >= 0) {
#line 613 "WorkspaceManager.c"
					gboolean* _tmp19_;
					gint _tmp19__length1;
#line 107 "../src/WorkspaceManager.vala"
					_tmp19_ = empty_workspaces;
#line 107 "../src/WorkspaceManager.vala"
					_tmp19__length1 = empty_workspaces_length1;
#line 107 "../src/WorkspaceManager.vala"
					_tmp18_ = index < _tmp19__length1;
#line 622 "WorkspaceManager.c"
				} else {
#line 107 "../src/WorkspaceManager.vala"
					_tmp18_ = FALSE;
#line 626 "WorkspaceManager.c"
				}
#line 107 "../src/WorkspaceManager.vala"
				if (_tmp18_) {
#line 630 "WorkspaceManager.c"
					gboolean* _tmp20_;
					gint _tmp20__length1;
#line 108 "../src/WorkspaceManager.vala"
					_tmp20_ = empty_workspaces;
#line 108 "../src/WorkspaceManager.vala"
					_tmp20__length1 = empty_workspaces_length1;
#line 108 "../src/WorkspaceManager.vala"
					_tmp20_[index] = FALSE;
#line 639 "WorkspaceManager.c"
				}
#line 105 "../src/WorkspaceManager.vala"
				_g_object_unref0 (startup_sequence);
#line 643 "WorkspaceManager.c"
			}
		}
	}
#line 113 "../src/WorkspaceManager.vala"
	_tmp21_ = display;
#line 113 "../src/WorkspaceManager.vala"
	_tmp22_ = meta_display_get_compositor (_tmp21_);
#line 113 "../src/WorkspaceManager.vala"
	_tmp23_ = meta_compositor_get_window_actors (_tmp22_);
#line 113 "../src/WorkspaceManager.vala"
	window_actors = _tmp23_;
#line 117 "../src/WorkspaceManager.vala"
	_tmp24_ = window_actors;
#line 657 "WorkspaceManager.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 117 "../src/WorkspaceManager.vala"
		actor_collection = _tmp24_;
#line 117 "../src/WorkspaceManager.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 665 "WorkspaceManager.c"
			MetaWindowActor* _tmp25_;
			MetaWindowActor* actor = NULL;
#line 117 "../src/WorkspaceManager.vala"
			_tmp25_ = _g_object_ref0 ((MetaWindowActor*) actor_it->data);
#line 117 "../src/WorkspaceManager.vala"
			actor = _tmp25_;
#line 672 "WorkspaceManager.c"
			{
				MetaWindow* win = NULL;
				MetaWindowActor* _tmp26_;
				MetaWindow* _tmp27_;
				MetaWindow* _tmp28_;
				MetaWindow* _tmp29_;
				gboolean _tmp30_ = FALSE;
				gboolean _tmp31_ = FALSE;
				MetaWindow* _tmp32_;
				gboolean* _tmp38_;
				gint _tmp38__length1;
				MetaWindow* _tmp39_;
				MetaWorkspace* _tmp40_;
#line 118 "../src/WorkspaceManager.vala"
				_tmp26_ = actor;
#line 118 "../src/WorkspaceManager.vala"
				_tmp27_ = meta_window_actor_get_meta_window (_tmp26_);
#line 118 "../src/WorkspaceManager.vala"
				_tmp28_ = _tmp27_;
#line 118 "../src/WorkspaceManager.vala"
				_tmp29_ = _g_object_ref0 (_tmp28_);
#line 118 "../src/WorkspaceManager.vala"
				win = _tmp29_;
#line 120 "../src/WorkspaceManager.vala"
				_tmp32_ = win;
#line 120 "../src/WorkspaceManager.vala"
				if (_tmp32_ == NULL) {
#line 120 "../src/WorkspaceManager.vala"
					_tmp31_ = TRUE;
#line 702 "WorkspaceManager.c"
				} else {
					MetaWindow* _tmp33_;
					gboolean _tmp34_;
					gboolean _tmp35_;
#line 120 "../src/WorkspaceManager.vala"
					_tmp33_ = win;
#line 120 "../src/WorkspaceManager.vala"
					g_object_get (_tmp33_, "on-all-workspaces", &_tmp34_, NULL);
#line 120 "../src/WorkspaceManager.vala"
					_tmp35_ = _tmp34_;
#line 120 "../src/WorkspaceManager.vala"
					_tmp31_ = _tmp35_;
#line 715 "WorkspaceManager.c"
				}
#line 120 "../src/WorkspaceManager.vala"
				if (_tmp31_) {
#line 120 "../src/WorkspaceManager.vala"
					_tmp30_ = TRUE;
#line 721 "WorkspaceManager.c"
				} else {
					MetaWindow* _tmp36_;
					MetaWorkspace* _tmp37_;
#line 120 "../src/WorkspaceManager.vala"
					_tmp36_ = win;
#line 120 "../src/WorkspaceManager.vala"
					_tmp37_ = meta_window_get_workspace (_tmp36_);
#line 120 "../src/WorkspaceManager.vala"
					_tmp30_ = _tmp37_ == NULL;
#line 731 "WorkspaceManager.c"
				}
#line 120 "../src/WorkspaceManager.vala"
				if (_tmp30_) {
#line 121 "../src/WorkspaceManager.vala"
					_g_object_unref0 (win);
#line 121 "../src/WorkspaceManager.vala"
					_g_object_unref0 (actor);
#line 121 "../src/WorkspaceManager.vala"
					continue;
#line 741 "WorkspaceManager.c"
				}
#line 124 "../src/WorkspaceManager.vala"
				_tmp38_ = empty_workspaces;
#line 124 "../src/WorkspaceManager.vala"
				_tmp38__length1 = empty_workspaces_length1;
#line 124 "../src/WorkspaceManager.vala"
				_tmp39_ = win;
#line 124 "../src/WorkspaceManager.vala"
				_tmp40_ = meta_window_get_workspace (_tmp39_);
#line 124 "../src/WorkspaceManager.vala"
				_tmp38_[meta_workspace_index (_tmp40_)] = FALSE;
#line 117 "../src/WorkspaceManager.vala"
				_g_object_unref0 (win);
#line 117 "../src/WorkspaceManager.vala"
				_g_object_unref0 (actor);
#line 757 "WorkspaceManager.c"
			}
		}
	}
#line 128 "../src/WorkspaceManager.vala"
	_tmp41_ = empty_workspaces;
#line 128 "../src/WorkspaceManager.vala"
	_tmp41__length1 = empty_workspaces_length1;
#line 128 "../src/WorkspaceManager.vala"
	_tmp42_ = empty_workspaces;
#line 128 "../src/WorkspaceManager.vala"
	_tmp42__length1 = empty_workspaces_length1;
#line 128 "../src/WorkspaceManager.vala"
	_tmp43_ = _tmp41_[_tmp42__length1 - 1];
#line 128 "../src/WorkspaceManager.vala"
	if (!_tmp43_) {
#line 773 "WorkspaceManager.c"
		MetaWorkspaceManager* _tmp44_;
		MetaDisplay* _tmp45_;
#line 129 "../src/WorkspaceManager.vala"
		_tmp44_ = manager;
#line 129 "../src/WorkspaceManager.vala"
		_tmp45_ = display;
#line 129 "../src/WorkspaceManager.vala"
		meta_workspace_manager_append_new_workspace (_tmp44_, FALSE, meta_display_get_current_time (_tmp45_));
#line 130 "../src/WorkspaceManager.vala"
		_vala_array_add10 (&empty_workspaces, &empty_workspaces_length1, &_empty_workspaces_size_, TRUE);
#line 784 "WorkspaceManager.c"
	}
#line 133 "../src/WorkspaceManager.vala"
	_tmp46_ = empty_workspaces;
#line 133 "../src/WorkspaceManager.vala"
	_tmp46__length1 = empty_workspaces_length1;
#line 133 "../src/WorkspaceManager.vala"
	last_index = _tmp46__length1 - 1;
#line 135 "../src/WorkspaceManager.vala"
	last_empty_index = 0;
#line 794 "WorkspaceManager.c"
	{
		gint i = 0;
#line 136 "../src/WorkspaceManager.vala"
		i = last_index;
#line 799 "WorkspaceManager.c"
		{
			gboolean _tmp47_ = FALSE;
#line 136 "../src/WorkspaceManager.vala"
			_tmp47_ = TRUE;
#line 136 "../src/WorkspaceManager.vala"
			while (TRUE) {
#line 806 "WorkspaceManager.c"
				gboolean* _tmp49_;
				gint _tmp49__length1;
				gboolean _tmp50_;
#line 136 "../src/WorkspaceManager.vala"
				if (!_tmp47_) {
#line 812 "WorkspaceManager.c"
					gint _tmp48_;
#line 136 "../src/WorkspaceManager.vala"
					_tmp48_ = i;
#line 136 "../src/WorkspaceManager.vala"
					i = _tmp48_ - 1;
#line 818 "WorkspaceManager.c"
				}
#line 136 "../src/WorkspaceManager.vala"
				_tmp47_ = FALSE;
#line 136 "../src/WorkspaceManager.vala"
				if (!(i >= 0)) {
#line 136 "../src/WorkspaceManager.vala"
					break;
#line 826 "WorkspaceManager.c"
				}
#line 137 "../src/WorkspaceManager.vala"
				_tmp49_ = empty_workspaces;
#line 137 "../src/WorkspaceManager.vala"
				_tmp49__length1 = empty_workspaces_length1;
#line 137 "../src/WorkspaceManager.vala"
				_tmp50_ = _tmp49_[i];
#line 137 "../src/WorkspaceManager.vala"
				if (!_tmp50_) {
#line 138 "../src/WorkspaceManager.vala"
					last_empty_index = i + 1;
#line 139 "../src/WorkspaceManager.vala"
					break;
#line 840 "WorkspaceManager.c"
				}
			}
		}
	}
#line 143 "../src/WorkspaceManager.vala"
	_tmp51_ = self->priv->_wm;
#line 143 "../src/WorkspaceManager.vala"
	if (!gala_window_manager_is_modal (_tmp51_)) {
#line 849 "WorkspaceManager.c"
		gint active_index = 0;
		MetaWorkspaceManager* _tmp52_;
		gboolean* _tmp53_;
		gint _tmp53__length1;
#line 144 "../src/WorkspaceManager.vala"
		_tmp52_ = manager;
#line 144 "../src/WorkspaceManager.vala"
		active_index = meta_workspace_manager_get_active_workspace_index (_tmp52_);
#line 145 "../src/WorkspaceManager.vala"
		_tmp53_ = empty_workspaces;
#line 145 "../src/WorkspaceManager.vala"
		_tmp53__length1 = empty_workspaces_length1;
#line 145 "../src/WorkspaceManager.vala"
		_tmp53_[active_index] = FALSE;
#line 864 "WorkspaceManager.c"
	}
	{
		gint i = 0;
#line 150 "../src/WorkspaceManager.vala"
		i = last_index;
#line 870 "WorkspaceManager.c"
		{
			gboolean _tmp54_ = FALSE;
#line 150 "../src/WorkspaceManager.vala"
			_tmp54_ = TRUE;
#line 150 "../src/WorkspaceManager.vala"
			while (TRUE) {
#line 877 "WorkspaceManager.c"
				gboolean _tmp56_ = FALSE;
				gboolean* _tmp57_;
				gint _tmp57__length1;
				gboolean _tmp58_;
				MetaWorkspace* workspace = NULL;
				MetaWorkspaceManager* _tmp59_;
				MetaWorkspace* _tmp60_;
				MetaWorkspace* _tmp61_;
				MetaWorkspace* _tmp62_;
				MetaWorkspaceManager* _tmp63_;
				MetaWorkspace* _tmp64_;
				MetaWorkspaceManager* _tmp78_;
				MetaWorkspace* _tmp79_;
				MetaDisplay* _tmp80_;
#line 150 "../src/WorkspaceManager.vala"
				if (!_tmp54_) {
#line 894 "WorkspaceManager.c"
					gint _tmp55_;
#line 150 "../src/WorkspaceManager.vala"
					_tmp55_ = i;
#line 150 "../src/WorkspaceManager.vala"
					i = _tmp55_ - 1;
#line 900 "WorkspaceManager.c"
				}
#line 150 "../src/WorkspaceManager.vala"
				_tmp54_ = FALSE;
#line 150 "../src/WorkspaceManager.vala"
				if (!(i >= 0)) {
#line 150 "../src/WorkspaceManager.vala"
					break;
#line 908 "WorkspaceManager.c"
				}
#line 151 "../src/WorkspaceManager.vala"
				_tmp57_ = empty_workspaces;
#line 151 "../src/WorkspaceManager.vala"
				_tmp57__length1 = empty_workspaces_length1;
#line 151 "../src/WorkspaceManager.vala"
				_tmp58_ = _tmp57_[i];
#line 151 "../src/WorkspaceManager.vala"
				if (!_tmp58_) {
#line 151 "../src/WorkspaceManager.vala"
					_tmp56_ = TRUE;
#line 920 "WorkspaceManager.c"
				} else {
#line 151 "../src/WorkspaceManager.vala"
					_tmp56_ = i == last_empty_index;
#line 924 "WorkspaceManager.c"
				}
#line 151 "../src/WorkspaceManager.vala"
				if (_tmp56_) {
#line 152 "../src/WorkspaceManager.vala"
					continue;
#line 930 "WorkspaceManager.c"
				}
#line 155 "../src/WorkspaceManager.vala"
				_tmp59_ = manager;
#line 155 "../src/WorkspaceManager.vala"
				_tmp60_ = meta_workspace_manager_get_workspace_by_index (_tmp59_, i);
#line 155 "../src/WorkspaceManager.vala"
				_tmp61_ = _g_object_ref0 (_tmp60_);
#line 155 "../src/WorkspaceManager.vala"
				workspace = _tmp61_;
#line 157 "../src/WorkspaceManager.vala"
				_tmp62_ = workspace;
#line 157 "../src/WorkspaceManager.vala"
				_tmp63_ = manager;
#line 157 "../src/WorkspaceManager.vala"
				_tmp64_ = meta_workspace_manager_get_active_workspace (_tmp63_);
#line 157 "../src/WorkspaceManager.vala"
				if (_tmp62_ == _tmp64_) {
#line 948 "WorkspaceManager.c"
					MetaWorkspace* next = NULL;
					MetaWorkspace* _tmp65_;
					MetaWorkspace* _tmp66_;
					MetaWorkspace* _tmp67_;
					gboolean _tmp68_ = FALSE;
					MetaWorkspace* _tmp69_;
					MetaWorkspace* _tmp70_;
					MetaWorkspace* _tmp75_;
#line 158 "../src/WorkspaceManager.vala"
					next = NULL;
#line 160 "../src/WorkspaceManager.vala"
					_tmp65_ = workspace;
#line 160 "../src/WorkspaceManager.vala"
					_tmp66_ = meta_workspace_get_neighbor (_tmp65_, META_MOTION_LEFT);
#line 160 "../src/WorkspaceManager.vala"
					_tmp67_ = _g_object_ref0 (_tmp66_);
#line 160 "../src/WorkspaceManager.vala"
					_g_object_unref0 (next);
#line 160 "../src/WorkspaceManager.vala"
					next = _tmp67_;
#line 162 "../src/WorkspaceManager.vala"
					_tmp69_ = next;
#line 162 "../src/WorkspaceManager.vala"
					_tmp70_ = workspace;
#line 162 "../src/WorkspaceManager.vala"
					if (_tmp69_ == _tmp70_) {
#line 162 "../src/WorkspaceManager.vala"
						_tmp68_ = TRUE;
#line 977 "WorkspaceManager.c"
					} else {
						MetaWorkspace* _tmp71_;
#line 162 "../src/WorkspaceManager.vala"
						_tmp71_ = next;
#line 162 "../src/WorkspaceManager.vala"
						_tmp68_ = _tmp71_ == NULL;
#line 984 "WorkspaceManager.c"
					}
#line 162 "../src/WorkspaceManager.vala"
					if (_tmp68_) {
#line 988 "WorkspaceManager.c"
						MetaWorkspace* _tmp72_;
						MetaWorkspace* _tmp73_;
						MetaWorkspace* _tmp74_;
#line 163 "../src/WorkspaceManager.vala"
						_tmp72_ = workspace;
#line 163 "../src/WorkspaceManager.vala"
						_tmp73_ = meta_workspace_get_neighbor (_tmp72_, META_MOTION_RIGHT);
#line 163 "../src/WorkspaceManager.vala"
						_tmp74_ = _g_object_ref0 (_tmp73_);
#line 163 "../src/WorkspaceManager.vala"
						_g_object_unref0 (next);
#line 163 "../src/WorkspaceManager.vala"
						next = _tmp74_;
#line 1002 "WorkspaceManager.c"
					}
#line 166 "../src/WorkspaceManager.vala"
					_tmp75_ = next;
#line 166 "../src/WorkspaceManager.vala"
					if (_tmp75_ != NULL) {
#line 1008 "WorkspaceManager.c"
						MetaWorkspace* _tmp76_;
						MetaDisplay* _tmp77_;
#line 167 "../src/WorkspaceManager.vala"
						_tmp76_ = next;
#line 167 "../src/WorkspaceManager.vala"
						_tmp77_ = display;
#line 167 "../src/WorkspaceManager.vala"
						meta_workspace_activate (_tmp76_, meta_display_get_current_time (_tmp77_));
#line 1017 "WorkspaceManager.c"
					}
#line 157 "../src/WorkspaceManager.vala"
					_g_object_unref0 (next);
#line 1021 "WorkspaceManager.c"
				}
#line 171 "../src/WorkspaceManager.vala"
				_tmp78_ = manager;
#line 171 "../src/WorkspaceManager.vala"
				_tmp79_ = workspace;
#line 171 "../src/WorkspaceManager.vala"
				_tmp80_ = display;
#line 171 "../src/WorkspaceManager.vala"
				meta_workspace_manager_remove_workspace (_tmp78_, _tmp79_, meta_display_get_current_time (_tmp80_));
#line 150 "../src/WorkspaceManager.vala"
				_g_object_unref0 (workspace);
#line 1033 "WorkspaceManager.c"
			}
		}
	}
#line 174 "../src/WorkspaceManager.vala"
	self->priv->check_workspaces_id = (guint) 0;
#line 175 "../src/WorkspaceManager.vala"
	result = G_SOURCE_REMOVE;
#line 175 "../src/WorkspaceManager.vala"
	empty_workspaces = (g_free (empty_workspaces), NULL);
#line 175 "../src/WorkspaceManager.vala"
	return result;
#line 1045 "WorkspaceManager.c"
}

GalaWindowManager*
gala_workspace_manager_get_wm (GalaWorkspaceManager* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 18 "../src/WorkspaceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 18 "../src/WorkspaceManager.vala"
	result = _tmp0_;
#line 18 "../src/WorkspaceManager.vala"
	return result;
#line 1061 "WorkspaceManager.c"
}

static void
gala_workspace_manager_set_wm (GalaWorkspaceManager* self,
                               GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 18 "../src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/WorkspaceManager.vala"
	old_value = gala_workspace_manager_get_wm (self);
#line 18 "../src/WorkspaceManager.vala"
	if (old_value != value) {
#line 1075 "WorkspaceManager.c"
		GalaWindowManager* _tmp0_;
#line 18 "../src/WorkspaceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/WorkspaceManager.vala"
		_g_object_unref0 (self->priv->_wm);
#line 18 "../src/WorkspaceManager.vala"
		self->priv->_wm = _tmp0_;
#line 18 "../src/WorkspaceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY]);
#line 1085 "WorkspaceManager.c"
	}
}

static void
_gala_workspace_manager_queue_check_workspaces_meta_workspace_manager_workspace_switched (MetaWorkspaceManager* _sender,
                                                                                          gint object,
                                                                                          gint p0,
                                                                                          MetaMotionDirection p1,
                                                                                          gpointer self)
{
#line 37 "../src/WorkspaceManager.vala"
	gala_workspace_manager_queue_check_workspaces ((GalaWorkspaceManager*) self);
#line 1098 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_workspace_added_meta_workspace_manager_workspace_added (MetaWorkspaceManager* _sender,
                                                                                gint object,
                                                                                gpointer self)
{
#line 38 "../src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
#line 1108 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_entered_monitor_meta_display_window_entered_monitor (MetaDisplay* _sender,
                                                                                    gint object,
                                                                                    MetaWindow* p0,
                                                                                    gpointer self)
{
#line 39 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 1119 "WorkspaceManager.c"
}

static void
_gala_workspace_manager_window_left_monitor_meta_display_window_left_monitor (MetaDisplay* _sender,
                                                                              gint object,
                                                                              MetaWindow* p0,
                                                                              gpointer self)
{
#line 40 "../src/WorkspaceManager.vala"
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 1130 "WorkspaceManager.c"
}

static GObject *
gala_workspace_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp2_;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspaceManager* _tmp4_;
	MetaWorkspaceManager* _tmp9_;
	MetaWorkspaceManager* _tmp10_;
	MetaDisplay* _tmp11_;
	MetaDisplay* _tmp12_;
#line 27 "../src/WorkspaceManager.vala"
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
#line 27 "../src/WorkspaceManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 27 "../src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 28 "../src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 28 "../src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 28 "../src/WorkspaceManager.vala"
	display = _tmp1_;
#line 29 "../src/WorkspaceManager.vala"
	_tmp2_ = display;
#line 29 "../src/WorkspaceManager.vala"
	_tmp3_ = meta_display_get_workspace_manager (_tmp2_);
#line 29 "../src/WorkspaceManager.vala"
	manager = _tmp3_;
#line 31 "../src/WorkspaceManager.vala"
	_tmp4_ = manager;
#line 31 "../src/WorkspaceManager.vala"
	meta_workspace_manager_override_workspace_layout (_tmp4_, META_DISPLAY_TOPLEFT, FALSE, 1, -1);
#line 1174 "WorkspaceManager.c"
	{
		gint i = 0;
#line 33 "../src/WorkspaceManager.vala"
		i = 0;
#line 1179 "WorkspaceManager.c"
		{
			gboolean _tmp5_ = FALSE;
#line 33 "../src/WorkspaceManager.vala"
			_tmp5_ = TRUE;
#line 33 "../src/WorkspaceManager.vala"
			while (TRUE) {
#line 1186 "WorkspaceManager.c"
				MetaWorkspaceManager* _tmp7_;
				MetaWorkspaceManager* _tmp8_;
#line 33 "../src/WorkspaceManager.vala"
				if (!_tmp5_) {
#line 1191 "WorkspaceManager.c"
					gint _tmp6_;
#line 33 "../src/WorkspaceManager.vala"
					_tmp6_ = i;
#line 33 "../src/WorkspaceManager.vala"
					i = _tmp6_ + 1;
#line 1197 "WorkspaceManager.c"
				}
#line 33 "../src/WorkspaceManager.vala"
				_tmp5_ = FALSE;
#line 33 "../src/WorkspaceManager.vala"
				_tmp7_ = manager;
#line 33 "../src/WorkspaceManager.vala"
				if (!(i < meta_workspace_manager_get_n_workspaces (_tmp7_))) {
#line 33 "../src/WorkspaceManager.vala"
					break;
#line 1207 "WorkspaceManager.c"
				}
#line 34 "../src/WorkspaceManager.vala"
				_tmp8_ = manager;
#line 34 "../src/WorkspaceManager.vala"
				gala_workspace_manager_workspace_added (self, _tmp8_, i);
#line 1213 "WorkspaceManager.c"
			}
		}
	}
#line 37 "../src/WorkspaceManager.vala"
	_tmp9_ = manager;
#line 37 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp9_, "workspace-switched", (GCallback) _gala_workspace_manager_queue_check_workspaces_meta_workspace_manager_workspace_switched, self, G_CONNECT_AFTER);
#line 38 "../src/WorkspaceManager.vala"
	_tmp10_ = manager;
#line 38 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp10_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_workspace_manager_workspace_added, self, 0);
#line 39 "../src/WorkspaceManager.vala"
	_tmp11_ = display;
#line 39 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp11_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_display_window_entered_monitor, self, 0);
#line 40 "../src/WorkspaceManager.vala"
	_tmp12_ = display;
#line 40 "../src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp12_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_display_window_left_monitor, self, 0);
#line 27 "../src/WorkspaceManager.vala"
	return obj;
#line 1235 "WorkspaceManager.c"
}

static void
gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass,
                                   gpointer klass_data)
{
#line 7 "../src/WorkspaceManager.vala"
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/WorkspaceManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaWorkspaceManager_private_offset);
#line 7 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
#line 7 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
#line 7 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
#line 7 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
#line 7 "../src/WorkspaceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM_PROPERTY, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1256 "WorkspaceManager.c"
}

static void
gala_workspace_manager_instance_init (GalaWorkspaceManager * self,
                                      gpointer klass)
{
#line 7 "../src/WorkspaceManager.vala"
	self->priv = gala_workspace_manager_get_instance_private (self);
#line 20 "../src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = 0;
#line 21 "../src/WorkspaceManager.vala"
	self->priv->check_workspaces_id = (guint) 0;
#line 1269 "WorkspaceManager.c"
}

static void
gala_workspace_manager_finalize (GObject * obj)
{
	GalaWorkspaceManager * self;
#line 7 "../src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 18 "../src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->_wm);
#line 7 "../src/WorkspaceManager.vala"
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
#line 1282 "WorkspaceManager.c"
}

 G_GNUC_NO_INLINE static GType
gala_workspace_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
	GType gala_workspace_manager_type_id;
	gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
	GalaWorkspaceManager_private_offset = g_type_add_instance_private (gala_workspace_manager_type_id, sizeof (GalaWorkspaceManagerPrivate));
	return gala_workspace_manager_type_id;
}

GType
gala_workspace_manager_get_type (void)
{
	static gsize gala_workspace_manager_type_id__once = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__once)) {
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = gala_workspace_manager_get_type_once ();
		g_once_init_leave (&gala_workspace_manager_type_id__once, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__once;
}

static void
_vala_gala_workspace_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 7 "../src/WorkspaceManager.vala"
	switch (property_id) {
#line 7 "../src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 7 "../src/WorkspaceManager.vala"
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
#line 7 "../src/WorkspaceManager.vala"
		break;
#line 1323 "WorkspaceManager.c"
		default:
#line 7 "../src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/WorkspaceManager.vala"
		break;
#line 1329 "WorkspaceManager.c"
	}
}

static void
_vala_gala_workspace_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 7 "../src/WorkspaceManager.vala"
	switch (property_id) {
#line 7 "../src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
#line 7 "../src/WorkspaceManager.vala"
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
#line 7 "../src/WorkspaceManager.vala"
		break;
#line 1349 "WorkspaceManager.c"
		default:
#line 7 "../src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/WorkspaceManager.vala"
		break;
#line 1355 "WorkspaceManager.c"
	}
}

